/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 21 "race-class.y"

#include "config.h"
#include <stdlib.h>
#include "argz.h"
#include "xvasprintf.h"
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <netinet/in.h>
#include <dirent.h>

#include "st.h"
#include "opts.h"
#include "race-class.h"
#include "object_constant.h"



/*
 * defined_t is used to indicate whether all fields have been defined
 */

typedef struct {
    unsigned	age: 1,
		infra_vision: 1,
		male_height: 1,
		male_weight: 1,
		female_height: 1,
		female_weight: 1,
		hit_points: 1,
		disarming: 1,
		search_chance: 1,
		stealth_factor: 1,
		frequency_of_search: 1,
		base_to_hit: 1,
		base_to_hit_with_bows: 1,
		saving_throw: 1,
		strength_modifier: 1,
		intelligence_modifier: 1,
		wisdom_modifier: 1,
		dexterity_modifier: 1,
		constitution_modifier: 1,
		charisma_modifier: 1,
		experience_factor: 1,
		classes: 1,
		store_price_adjust_by_race: 1,
		shopkeep: 1,
		backgrounds: 1;
} race_defined_t;

typedef struct {
    unsigned    hit_points: 1,
		disarming: 1,
		search_chance: 1,
		stealth_factor: 1,
		frequency_of_search: 1,
		base_to_hit: 1,
		base_to_hit_with_bows: 1,
		saving_throw: 1,
		strength_modifier: 1,
		intelligence_modifier: 1,
		wisdom_modifier: 1,
		dexterity_modifier: 1,
		constitution_modifier: 1,
		charisma_modifier: 1,
		experience_factor: 1,
                adjust_base_to_hit: 1,
                adjust_base_to_hit_with_bows: 1,
                adjust_use_device: 1,
                adjust_disarming: 1,
                adjust_saving_throw: 1,
                titles: 1,
                spells: 1,
                prayers: 1;
} class_defined_t;

typedef struct {
    unsigned    store: 1,
                haggle_per: 1,
                inflate: 1,
                max_insults: 1,
                max_cost: 1;
} shopkeep_defined_t;

typedef struct {
    unsigned    roll: 1,
                social_class_bonus: 1;
} fragment_defined_t;

typedef struct {
    unsigned    adjust_base_to_hit: 1,
                adjust_base_to_hit_with_bows: 1,
                adjust_use_device: 1,
                adjust_disarming: 1,
                adjust_saving_throw: 1;
} adjust_per_one_third_level_defined_t;

typedef struct {
    unsigned    roll: 1,
                social_class_bonus: 1;
} background_defined_t;

typedef struct {
    unsigned    level: 1,
                mana: 1,
                fail: 1,
                exp: 1;
} spell_defined_t;

typedef struct
{
  char *race;
  int price;
} race_price_t;

typedef struct
{
  race_type r;
  race_price_t *price_adjust;
  int num_price_adjust;
  char *classes_argz;
  size_t classes_len;
  owner_type *shopkeeps;
  int num_shopkeeps;
  background_type *backgrounds;
  int num_backgrounds;
} race_t;

typedef struct
{
  int idx;
  race_t val;
  race_defined_t def;
  int line_no_for_classes;
  int line_no_for_price_adjust;
} race_template_t;


typedef struct
{
  int idx;
  spell_type s;
  int line_no;
} spell_t;

typedef struct
{
  class_type c;
  char *male_titles_argz;
  size_t male_titles_len;
  char *female_titles_argz;
  size_t female_titles_len;
  int adjust_per_one_third_level[MAX_LEV_ADJ];
  spell_t *spells;
  int num_spells;
  spell_t *prayers;
  int num_prayers;
} class_t;

typedef struct
{
  int idx;
  class_t val;
  class_defined_t def;
} class_template_t;

typedef struct
{
  owner_type val;
  shopkeep_defined_t def;
  int line_no;
} shopkeep_template_t;

typedef struct
{
  background_type val;
  background_defined_t def;
  int line_no;
} background_template_t;

typedef struct
{
  background_type val;
  fragment_defined_t def;
} fragment_template_t;

typedef struct
{
  spell_t val;
  spell_defined_t def;
} spell_template_t;


struct name_block_t
{
  char *name;
  char *description;
  int val;
};

struct name_block_t * spell_names;
int num_spells_named;
struct name_block_t* prayer_names;
int num_prayers_named;

/*
 * symInit_t is used to initialize symbol tables with integer values
 */

typedef struct 
{
  char *name;
  int32u val;
} symInit_t;



/*
 * Maximum token length = maximum string constant length
 * Also, trim the stack to an "acceptable" size.
 */

#define	MAX_TOK_LEN	1024		/* maximum acceptable token length  */
#define	YYSTACKSIZE	128

#define GEN_TYPE_TMPL	256		/* type of a template for st	    */

/*
 * Globals used by the tokenizer (lexical analyzer)
 */

#define INPUT_BUF_SIZE 2048
static char	inputBuf[INPUT_BUF_SIZE] = { 0 };
					/* input line buffer		    */
static char	*inputBufp = inputBuf;	/* position in input line buffer    */
static int	lineNo = 0;		/* number of current line	    */
static FILE	*input_F;
static char	tokStr[MAX_TOK_LEN];	/* text of current token	    */
static	int	tokType;		/* type of current token	    */

static race_template_t blankRace;	/* blank race for init-ing     */
static race_template_t tmpRace;		/* working race for current race   */

static class_template_t blankClass;	/* blank class for init-ing     */
static class_template_t tmpClass;	/* working class for current class */

static shopkeep_template_t blankShopkeep;
static shopkeep_template_t tmpShopkeep;
static fragment_template_t blankFragment;
static fragment_template_t tmpFragment;

int num_shopkeeps;
int *experience_levels;
int num_experience_levels;
background_template_t tmpBackground;
background_template_t blankBackground;
spell_template_t tmpSpell;
spell_template_t blankSpell;
spell_template_t tmpPrayer;
spell_template_t blankPrayer;

/*
 * Global symbol tables
 */

static st_Table_Pt keywordT_P;		/* parser's keywords		    */
static st_Table_Pt spellsT_P;		/* spells that go in books	    */
static st_Table_Pt prayersT_P;		/* prayers that go in books	    */
static st_Table_Pt raceT_P;		/* race definitions		    */
static st_Table_Pt classT_P;		/* class definitions */

static symInit_t
spellsInit[] = 
{
    { "magic_missile", 0},
    { "detect_monsters", 1},
    { "phase_door", 2},
    { "light_area", 3},
    { "cure_light_wounds", 4},
    { "find_hidden_traps_and_doors", 5},
    { "stinking_cloud", 6},
    { "confusion", 7},
    { "lightning_bolt", 8},
    { "trap_and_door_destruction", 9},
    { "sleep_i", 10},
    { "cure_poison", 11},
    { "teleport_self", 12},
    { "remove_curse", 13},
    { "frost_bolt", 14},
    { "turn_stone_to_mud", 15},
    { "create_food", 16},
    { "recharge_item_i", 17},
    { "sleep_ii", 18},
    { "polymorph_other", 19},
    { "identify", 20},
    { "sleep_iii", 21},
    { "fire_bolt", 22},
    { "slow_monster", 23},
    { "frost_ball", 24},
    { "recharge_item_ii", 25},
    { "teleport_other", 26},
    { "haste_self", 27},
    { "fire_ball", 28},
    { "resist_poison_gas", 29},
    { "word_of_destruction", 30},
    { "genocide", 31},
    { NULL, 0 },
};

static symInit_t
prayersInit[] = 
{
    { "detect_evil", 0},
    { "cure_light_wounds", 1},
    { "bless", 2},
    { "remove_fear", 3},
    { "call_light", 4},
    { "find_traps", 5},
    { "detect_doors_and_stairs", 6},
    { "slow_poison", 7},
    { "blind_creature", 8},
    { "portal", 9},
    { "cure_medium_wounds", 10},
    { "chant", 11},
    { "sanctuary", 12},
    { "create_food", 13},
    { "remove_curse", 14},
    { "resist_heat_and_cold", 15},
    { "neutralize_poison", 16},
    { "orb_of_draining", 17},
    { "cure_serious_wounds", 18},
    { "sense_invisible", 19},
    { "protection_from_evil", 20},
    { "earthquake", 21},
    { "sense_surroundings", 22},
    { "cure_critical_wounds", 23},
    { "turn_undead", 24},
    { "pray_prayer", 25},
    { "dispel_undead", 26},
    { "heal", 27},
    { "dispel_evil", 28},
    { "resist_poison_gas", 29},
    { "glyph_of_warding", 30},
    { "holy_word", 31},
    { NULL, 0 },
};
/*
 * Function declarations
 */

void PutRace (char *s, race_template_t *tmpl_P, int consistency_check);
void PutShopkeep(shopkeep_template_t *tmpl_P, int consistency_check);
void PutBackground(background_template_t *tmpl_P, int consistency_check);
void PutSpell (char *s, spell_template_t *tmpl_P, int consistency_check);
void PutPrayer (char *s, spell_template_t *tmpl_P, int consistency_check);
void PutSpellInfo(char *s1, char *s2, char *s3, int consistency_check);
void PutPrayerInfo(char *s1, char *s2, char *s3, int consistency_check);
void CheckBackground (int chart, int next);
void PutClass (char *s, class_template_t *tmpl_P, int consistency_check);

int yyerror (char *s);


/* Line 371 of yacc.c  */
#line 433 "race-class.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     RACE = 258,
     CLASS = 259,
     EXPERIENCE_LEVELS = 260,
     AGE = 261,
     MALE_HEIGHT = 262,
     MALE_WEIGHT = 263,
     FEMALE_HEIGHT = 264,
     FEMALE_WEIGHT = 265,
     INFRA_VISION = 266,
     ATTRIBUTES = 267,
     HIT_POINTS = 268,
     DISARMING = 269,
     SEARCH_CHANCE = 270,
     STEALTH_FACTOR = 271,
     FREQUENCY_OF_SEARCH = 272,
     BASE_TO_HIT = 273,
     BASE_TO_HIT_WITH_BOWS = 274,
     SAVING_THROW = 275,
     STRENGTH_MODIFIER = 276,
     INTELLIGENCE_MODIFIER = 277,
     WISDOM_MODIFIER = 278,
     DEXTERITY_MODIFIER = 279,
     CONSTITUTION_MODIFIER = 280,
     CHARISMA_MODIFIER = 281,
     EXPERIENCE_FACTOR = 282,
     CLASSES = 283,
     STORE_PRICE_ADJUST_BY_RACE = 284,
     SHOPKEEP = 285,
     STORE = 286,
     HAGGLE_PER = 287,
     INFLATE = 288,
     MAX_INSULTS = 289,
     MAX_COST = 290,
     BACKGROUNDS = 291,
     BACKGROUND = 292,
     FRAGMENT = 293,
     ROLL = 294,
     SOCIAL_CLASS_BONUS = 295,
     ADJUST_PER_ONE_THIRD_LEVEL = 296,
     MALE_TITLES = 297,
     FEMALE_TITLES = 298,
     SPELLS = 299,
     SPELL = 300,
     LEVEL = 301,
     MANA = 302,
     FAIL = 303,
     EXP = 304,
     PRAYERS = 305,
     PRAYER = 306,
     ADJUST_BASE_TO_HIT = 307,
     ADJUST_BASE_TO_HIT_WITH_BOWS = 308,
     ADJUST_USE_DEVICE = 309,
     ADJUST_DISARMING = 310,
     ADJUST_SAVING_THROW = 311,
     SPELL_INFO = 312,
     PRAYER_INFO = 313,
     IDENTIFIER = 314,
     FLOAT_LIT = 315,
     INT_LIT = 316,
     STRING_LIT = 317,
     BOOL_LIT = 318
   };
#endif
/* Tokens.  */
#define RACE 258
#define CLASS 259
#define EXPERIENCE_LEVELS 260
#define AGE 261
#define MALE_HEIGHT 262
#define MALE_WEIGHT 263
#define FEMALE_HEIGHT 264
#define FEMALE_WEIGHT 265
#define INFRA_VISION 266
#define ATTRIBUTES 267
#define HIT_POINTS 268
#define DISARMING 269
#define SEARCH_CHANCE 270
#define STEALTH_FACTOR 271
#define FREQUENCY_OF_SEARCH 272
#define BASE_TO_HIT 273
#define BASE_TO_HIT_WITH_BOWS 274
#define SAVING_THROW 275
#define STRENGTH_MODIFIER 276
#define INTELLIGENCE_MODIFIER 277
#define WISDOM_MODIFIER 278
#define DEXTERITY_MODIFIER 279
#define CONSTITUTION_MODIFIER 280
#define CHARISMA_MODIFIER 281
#define EXPERIENCE_FACTOR 282
#define CLASSES 283
#define STORE_PRICE_ADJUST_BY_RACE 284
#define SHOPKEEP 285
#define STORE 286
#define HAGGLE_PER 287
#define INFLATE 288
#define MAX_INSULTS 289
#define MAX_COST 290
#define BACKGROUNDS 291
#define BACKGROUND 292
#define FRAGMENT 293
#define ROLL 294
#define SOCIAL_CLASS_BONUS 295
#define ADJUST_PER_ONE_THIRD_LEVEL 296
#define MALE_TITLES 297
#define FEMALE_TITLES 298
#define SPELLS 299
#define SPELL 300
#define LEVEL 301
#define MANA 302
#define FAIL 303
#define EXP 304
#define PRAYERS 305
#define PRAYER 306
#define ADJUST_BASE_TO_HIT 307
#define ADJUST_BASE_TO_HIT_WITH_BOWS 308
#define ADJUST_USE_DEVICE 309
#define ADJUST_DISARMING 310
#define ADJUST_SAVING_THROW 311
#define SPELL_INFO 312
#define PRAYER_INFO 313
#define IDENTIFIER 314
#define FLOAT_LIT 315
#define INT_LIT 316
#define STRING_LIT 317
#define BOOL_LIT 318



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 395 "race-class.y"

	int ival;
	double dval;
	char sval[MAX_TOK_LEN];
	

/* Line 387 of yacc.c  */
#line 606 "race-class.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE yylval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* Copy the second part of user declarations.  */
/* Line 390 of yacc.c  */
#line 417 "race-class.y"

static symInit_t 
keywordInit[] = 
{
    { "race", RACE},
    { "class", CLASS},
    { "experience_levels", EXPERIENCE_LEVELS},
    { "age", AGE},
    { "male_height", MALE_HEIGHT},
    { "male_weight", MALE_WEIGHT},
    { "female_height", FEMALE_HEIGHT},
    { "female_weight", FEMALE_WEIGHT},
    { "infra_vision", INFRA_VISION},
    { "attributes", ATTRIBUTES},
    { "hit_points", HIT_POINTS},
    { "disarming", DISARMING},
    { "search_chance", SEARCH_CHANCE},
    { "stealth_factor", STEALTH_FACTOR},
    { "frequency_of_search", FREQUENCY_OF_SEARCH},
    { "base_to_hit", BASE_TO_HIT},
    { "base_to_hit_with_bows", BASE_TO_HIT_WITH_BOWS},
    { "saving_throw", SAVING_THROW},
    { "strength_modifier", STRENGTH_MODIFIER},
    { "intelligence_modifier", INTELLIGENCE_MODIFIER},
    { "wisdom_modifier", WISDOM_MODIFIER},
    { "dexterity_modifier", DEXTERITY_MODIFIER},
    { "constitution_modifier", CONSTITUTION_MODIFIER},
    { "charisma_modifier", CHARISMA_MODIFIER},
    { "experience_factor", EXPERIENCE_FACTOR},
    { "classes", CLASSES},
    { "store_price_adjust_by_race", STORE_PRICE_ADJUST_BY_RACE},
    { "shopkeep", SHOPKEEP},
    { "store", STORE},
    { "haggle_per", HAGGLE_PER},
    { "inflate", INFLATE},
    { "max_insults", MAX_INSULTS},
    { "max_cost", MAX_COST},
    { "backgrounds", BACKGROUNDS},
    { "background", BACKGROUND},
    { "fragment", FRAGMENT},
    { "roll", ROLL},
    { "social_class_bonus", SOCIAL_CLASS_BONUS},
    { "adjust_per_one_third_level", ADJUST_PER_ONE_THIRD_LEVEL},
    { "male_titles", MALE_TITLES},
    { "female_titles", FEMALE_TITLES},
    { "spells", SPELLS},
    { "spell", SPELL},
    { "level", LEVEL},
    { "mana", MANA},
    { "fail", FAIL},
    { "exp", EXP},
    { "prayers", PRAYERS},
    { "prayer", PRAYER},
    { "adjust_base_to_hit", ADJUST_BASE_TO_HIT},
    { "adjust_base_to_hit_with_bows", ADJUST_BASE_TO_HIT_WITH_BOWS},
    { "adjust_use_device", ADJUST_USE_DEVICE},
    { "adjust_disarming", ADJUST_DISARMING},
    { "adjust_saving_throw", ADJUST_SAVING_THROW},
    { "spell_info", SPELL_INFO},
    { "prayer_info", PRAYER_INFO},
    { NULL, 0 }
};

/* Line 390 of yacc.c  */
#line 698 "race-class.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  22
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   368

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  71
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  72
/* YYNRULES -- Number of rules.  */
#define YYNRULES  155
/* YYNRULES -- Number of states.  */
#define YYNSTATES  425

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   318

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,    65,     2,     2,     2,     2,
       2,     2,     2,     2,    70,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    68,    64,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    66,    69,    67,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     7,    11,    15,    19,    23,    26,    27,
      30,    33,    35,    38,    39,    45,    51,    55,    59,    63,
      67,    71,    72,    78,    82,    88,    94,   100,   106,   110,
     114,   118,   122,   126,   130,   134,   138,   142,   146,   150,
     154,   158,   162,   166,   171,   174,   176,   180,   181,   186,
     190,   194,   198,   199,   207,   211,   215,   216,   220,   224,
     230,   234,   238,   243,   246,   253,   257,   258,   261,   267,
     271,   272,   276,   280,   284,   288,   289,   293,   297,   301,
     305,   309,   313,   314,   318,   322,   326,   330,   334,   338,
     342,   346,   350,   354,   358,   362,   366,   370,   374,   379,
     383,   387,   388,   392,   396,   400,   404,   408,   413,   416,
     418,   422,   423,   428,   431,   433,   437,   438,   443,   446,
     450,   451,   457,   461,   465,   466,   470,   474,   478,   482,
     487,   490,   494,   495,   501,   505,   509,   510,   514,   518,
     522,   526,   531,   534,   536,   540,   541,   546,   549,   552,
     553,   560,   565,   568,   571,   572
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      72,     0,    -1,    77,    64,    72,    -1,    78,    64,    72,
      -1,   131,    64,    72,    -1,   135,    64,    72,    -1,   139,
      64,    72,    -1,    73,    72,    -1,    -1,    65,    74,    -1,
      75,    76,    -1,    59,    -1,    75,    76,    -1,    -1,     3,
      62,    66,    79,    67,    -1,     4,    62,    66,   103,    67,
      -1,    80,    64,    79,    -1,    81,    64,    79,    -1,    85,
      64,    79,    -1,    89,    64,    79,    -1,    93,    64,    79,
      -1,    -1,     6,    68,    61,    69,    61,    -1,    11,    68,
      61,    -1,     7,    68,    61,    69,    61,    -1,     8,    68,
      61,    69,    61,    -1,     9,    68,    61,    69,    61,    -1,
      10,    68,    61,    69,    61,    -1,    13,    68,    61,    -1,
      14,    68,    61,    -1,    15,    68,    61,    -1,    16,    68,
      61,    -1,    17,    68,    61,    -1,    18,    68,    61,    -1,
      19,    68,    61,    -1,    20,    68,    61,    -1,    21,    68,
      61,    -1,    22,    68,    61,    -1,    23,    68,    61,    -1,
      24,    68,    61,    -1,    25,    68,    61,    -1,    26,    68,
      61,    -1,    27,    68,    61,    -1,    28,    66,    82,    67,
      -1,    83,    84,    -1,    62,    -1,    70,    83,    84,    -1,
      -1,    29,    66,    86,    67,    -1,    87,    64,    88,    -1,
      62,    68,    61,    -1,    87,    64,    88,    -1,    -1,    30,
      62,    62,    62,    66,    90,    67,    -1,    92,    64,    91,
      -1,    92,    64,    91,    -1,    -1,    31,    68,    62,    -1,
      32,    68,    61,    -1,    33,    68,    61,    69,    61,    -1,
      34,    68,    61,    -1,    35,    68,    61,    -1,    36,    66,
      94,    67,    -1,    95,    96,    -1,    37,    61,    61,    66,
      97,    67,    -1,    70,    95,    96,    -1,    -1,    98,    99,
      -1,    38,    62,    66,   100,    67,    -1,    70,    98,    99,
      -1,    -1,   101,    64,   102,    -1,    39,    68,    61,    -1,
      40,    68,    61,    -1,   101,    64,   102,    -1,    -1,   104,
      64,   103,    -1,   105,    64,   103,    -1,   109,    64,   103,
      -1,   113,    64,   103,    -1,   117,    64,   103,    -1,   124,
      64,   103,    -1,    -1,    13,    68,    61,    -1,    14,    68,
      61,    -1,    15,    68,    61,    -1,    16,    68,    61,    -1,
      17,    68,    61,    -1,    18,    68,    61,    -1,    19,    68,
      61,    -1,    20,    68,    61,    -1,    21,    68,    61,    -1,
      22,    68,    61,    -1,    23,    68,    61,    -1,    24,    68,
      61,    -1,    25,    68,    61,    -1,    26,    68,    61,    -1,
      27,    68,    61,    -1,    41,    66,   106,    67,    -1,   108,
      64,   107,    -1,   108,    64,   107,    -1,    -1,    52,    68,
      61,    -1,    53,    68,    61,    -1,    54,    68,    61,    -1,
      55,    68,    61,    -1,    56,    68,    61,    -1,    42,    66,
     110,    67,    -1,   111,   112,    -1,    62,    -1,    70,   111,
     112,    -1,    -1,    43,    66,   114,    67,    -1,   115,   116,
      -1,    62,    -1,    70,   115,   116,    -1,    -1,    44,    66,
     118,    67,    -1,   120,   119,    -1,    70,   120,   119,    -1,
      -1,    45,    59,    66,   121,    67,    -1,   123,    64,   122,
      -1,   123,    64,   122,    -1,    -1,    46,    68,    61,    -1,
      47,    68,    61,    -1,    48,    68,    61,    -1,    49,    68,
      61,    -1,    50,    66,   125,    67,    -1,   127,   126,    -1,
      70,   127,   126,    -1,    -1,    51,    59,    66,   128,    67,
      -1,   130,    64,   129,    -1,   130,    64,   129,    -1,    -1,
      46,    68,    61,    -1,    47,    68,    61,    -1,    48,    68,
      61,    -1,    49,    68,    61,    -1,     5,    66,   132,    67,
      -1,   133,   134,    -1,    61,    -1,    70,   133,   134,    -1,
      -1,    57,    66,   136,    67,    -1,   138,   137,    -1,   138,
     137,    -1,    -1,    59,    68,    62,    70,    62,    64,    -1,
      58,    66,   140,    67,    -1,   142,   141,    -1,   142,   141,
      -1,    -1,    59,    68,    62,    70,    62,    64,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   504,   504,   505,   506,   507,   508,   509,   510,   513,
     517,   520,   524,   525,   528,   539,   550,   551,   552,   553,
     554,   555,   558,   562,   565,   569,   573,   577,   581,   584,
     587,   590,   593,   596,   599,   602,   605,   608,   611,   614,
     617,   620,   623,   628,   634,   637,   642,   643,   646,   651,
     654,   688,   689,   692,   709,   712,   713,   716,   727,   730,
     735,   738,   743,   747,   750,   764,   765,   768,   771,   779,
     780,   783,   786,   792,   797,   798,   801,   802,   803,   804,
     805,   806,   807,   810,   813,   816,   819,   822,   825,   828,
     831,   834,   837,   840,   843,   846,   849,   852,   857,   860,
     863,   864,   867,   871,   875,   879,   883,   889,   893,   896,
     920,   921,   924,   928,   931,   957,   958,   961,   964,   967,
     968,   971,   977,   980,   981,   984,   987,   990,   993,   998,
    1001,  1004,  1005,  1008,  1014,  1017,  1018,  1021,  1024,  1027,
    1030,  1035,  1038,  1041,  1062,  1063,  1066,  1069,  1072,  1073,
    1076,  1082,  1085,  1088,  1089,  1092
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "RACE", "CLASS", "EXPERIENCE_LEVELS",
  "AGE", "MALE_HEIGHT", "MALE_WEIGHT", "FEMALE_HEIGHT", "FEMALE_WEIGHT",
  "INFRA_VISION", "ATTRIBUTES", "HIT_POINTS", "DISARMING", "SEARCH_CHANCE",
  "STEALTH_FACTOR", "FREQUENCY_OF_SEARCH", "BASE_TO_HIT",
  "BASE_TO_HIT_WITH_BOWS", "SAVING_THROW", "STRENGTH_MODIFIER",
  "INTELLIGENCE_MODIFIER", "WISDOM_MODIFIER", "DEXTERITY_MODIFIER",
  "CONSTITUTION_MODIFIER", "CHARISMA_MODIFIER", "EXPERIENCE_FACTOR",
  "CLASSES", "STORE_PRICE_ADJUST_BY_RACE", "SHOPKEEP", "STORE",
  "HAGGLE_PER", "INFLATE", "MAX_INSULTS", "MAX_COST", "BACKGROUNDS",
  "BACKGROUND", "FRAGMENT", "ROLL", "SOCIAL_CLASS_BONUS",
  "ADJUST_PER_ONE_THIRD_LEVEL", "MALE_TITLES", "FEMALE_TITLES", "SPELLS",
  "SPELL", "LEVEL", "MANA", "FAIL", "EXP", "PRAYERS", "PRAYER",
  "ADJUST_BASE_TO_HIT", "ADJUST_BASE_TO_HIT_WITH_BOWS",
  "ADJUST_USE_DEVICE", "ADJUST_DISARMING", "ADJUST_SAVING_THROW",
  "SPELL_INFO", "PRAYER_INFO", "IDENTIFIER", "FLOAT_LIT", "INT_LIT",
  "STRING_LIT", "BOOL_LIT", "';'", "'#'", "'{'", "'}'", "':'", "'|'",
  "','", "$accept", "race_and_class", "comment_def", "comments", "comment",
  "more_comments", "race_def", "class_def", "race_attributes",
  "race_attribute", "classes_def", "ok_classes", "ok_class",
  "more_ok_classes", "price_race_adj", "race_prices", "race_price",
  "more_race_prices", "shopkeep_def", "shopkeep_attrs", "more_shop_attrs",
  "shopkeep_attr", "backgrounds_def", "backgrounds", "background",
  "more_backgrounds", "fragments", "fragment", "more_fragments",
  "frag_attrs", "frag_attr", "more_frag_attrs", "class_attributes",
  "class_attribute", "adjust_per_lev", "adj_attrs", "more_adj_attrs",
  "adj_attr", "male_titles_def", "male_titles", "male_title",
  "more_male_titles", "female_titles_def", "female_titles", "female_title",
  "more_female_titles", "spells_def", "spells", "more_spells", "spell",
  "spell_attrs", "more_spell_attrs", "spell_attr", "prayers_def",
  "prayers", "more_prayers", "prayer", "prayer_attrs", "more_prayer_attrs",
  "prayer_attr", "exp_levels_def", "exp_levels", "exp_level",
  "more_exp_levels", "spell_info_def", "spell_infos", "more_spell_infos",
  "spell_info", "prayer_info_def", "prayer_infos", "more_prayer_infos",
  "prayer_info", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    59,    35,   123,   125,    58,   124,
      44
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    71,    72,    72,    72,    72,    72,    72,    72,    73,
      74,    75,    76,    76,    77,    78,    79,    79,    79,    79,
      79,    79,    80,    80,    80,    80,    80,    80,    80,    80,
      80,    80,    80,    80,    80,    80,    80,    80,    80,    80,
      80,    80,    80,    81,    82,    83,    84,    84,    85,    86,
      87,    88,    88,    89,    90,    91,    91,    92,    92,    92,
      92,    92,    93,    94,    95,    96,    96,    97,    98,    99,
      99,   100,   101,   101,   102,   102,   103,   103,   103,   103,
     103,   103,   103,   104,   104,   104,   104,   104,   104,   104,
     104,   104,   104,   104,   104,   104,   104,   104,   105,   106,
     107,   107,   108,   108,   108,   108,   108,   109,   110,   111,
     112,   112,   113,   114,   115,   116,   116,   117,   118,   119,
     119,   120,   121,   122,   122,   123,   123,   123,   123,   124,
     125,   126,   126,   127,   128,   129,   129,   130,   130,   130,
     130,   131,   132,   133,   134,   134,   135,   136,   137,   137,
     138,   139,   140,   141,   141,   142
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     3,     3,     3,     3,     3,     2,     0,     2,
       2,     1,     2,     0,     5,     5,     3,     3,     3,     3,
       3,     0,     5,     3,     5,     5,     5,     5,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     4,     2,     1,     3,     0,     4,     3,
       3,     3,     0,     7,     3,     3,     0,     3,     3,     5,
       3,     3,     4,     2,     6,     3,     0,     2,     5,     3,
       0,     3,     3,     3,     3,     0,     3,     3,     3,     3,
       3,     3,     0,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     4,     3,
       3,     0,     3,     3,     3,     3,     3,     4,     2,     1,
       3,     0,     4,     2,     1,     3,     0,     4,     2,     3,
       0,     5,     3,     3,     0,     3,     3,     3,     3,     4,
       2,     3,     0,     5,     3,     3,     0,     3,     3,     3,
       3,     4,     2,     1,     3,     0,     4,     2,     2,     0,
       6,     4,     2,     2,     0,     6
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       8,     0,     0,     0,     0,     0,     0,     0,     8,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    11,
       9,    13,     1,     7,     8,     8,     8,     8,     8,    21,
      82,   143,     0,   145,     0,     0,   149,     0,     0,   154,
      13,    10,     2,     3,     4,     5,     6,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   141,     0,   142,     0,   146,
     147,   149,     0,   151,   152,   154,    12,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    14,    21,    21,    21,    21,    21,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    15,    82,
      82,    82,    82,    82,    82,   145,     0,   148,     0,   153,
       0,     0,     0,     0,     0,    23,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    45,     0,    47,     0,     0,     0,     0,     0,     0,
      66,    16,    17,    18,    19,    20,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,     0,     0,     0,     0,     0,     0,     0,   109,     0,
     111,   114,     0,   116,     0,     0,   120,     0,     0,   132,
      76,    77,    78,    79,    80,    81,   144,     0,     0,     0,
       0,     0,     0,     0,    43,     0,    44,     0,    48,    52,
       0,     0,    62,     0,    63,     0,     0,     0,     0,     0,
      98,   101,   107,     0,   108,   112,     0,   113,     0,   117,
       0,   118,     0,   129,     0,   130,     0,     0,    22,    24,
      25,    26,    27,    47,    50,     0,    49,     0,     0,    66,
     102,   103,   104,   105,   106,    99,     0,   111,   116,     0,
     120,     0,   132,   150,   155,    46,    52,     0,     0,     0,
       0,     0,     0,     0,     0,    65,   101,   110,   115,     0,
       0,     0,     0,     0,     0,   119,     0,     0,     0,     0,
       0,     0,   131,    51,     0,     0,     0,     0,     0,    53,
      56,     0,     0,    70,   100,     0,     0,     0,     0,   121,
     124,     0,     0,     0,     0,   133,   136,    57,    58,     0,
      60,    61,    54,     0,     0,    64,     0,    67,   125,   126,
     127,   128,   122,     0,   137,   138,   139,   140,   134,     0,
       0,    56,     0,    70,   124,   136,    59,    55,     0,     0,
       0,     0,    69,   123,   135,     0,     0,    68,    75,    72,
      73,     0,    71,    75,    74
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     7,     8,    20,    40,    41,     9,    10,    72,    73,
      74,   202,   203,   266,    75,   205,   305,   306,    76,   332,
     382,   383,    77,   209,   210,   274,   362,   363,   387,   410,
     421,   422,    98,    99,   100,   236,   315,   316,   101,   239,
     240,   284,   102,   242,   243,   287,   103,   245,   291,   246,
     343,   392,   393,   104,   248,   295,   249,   350,   398,   399,
      11,    32,    33,   107,    12,    35,   110,   111,    13,    38,
     114,   115
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -283
static const yytype_int16 yypact[] =
{
      -3,   -44,    -9,    19,    25,    26,    34,    94,    -3,    31,
      32,    33,    36,    37,    38,    39,    42,    40,    43,  -283,
    -283,    34,  -283,  -283,    -3,    -3,    -3,    -3,    -3,    50,
     -10,  -283,    44,    28,    45,    47,    40,    48,    51,    43,
      34,  -283,  -283,  -283,  -283,  -283,  -283,    49,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    46,    74,
      79,    76,    77,    81,    82,    83,    84,    85,    75,    86,
      87,    88,    89,    90,    91,    92,    93,    95,    96,    97,
      98,    99,   100,   103,   104,   105,   106,   107,   108,   110,
     112,   113,   114,   115,   116,  -283,    42,  -283,   119,  -283,
    -283,    40,   120,  -283,  -283,    43,  -283,   101,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,    72,  -283,    50,    50,    50,    50,    50,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   -26,   161,   162,   177,   102,  -283,   -10,
     -10,   -10,   -10,   -10,   -10,    28,    80,  -283,   163,  -283,
     165,   166,   167,   168,   169,  -283,  -283,  -283,  -283,  -283,
    -283,  -283,  -283,  -283,  -283,  -283,  -283,  -283,  -283,  -283,
    -283,  -283,   164,   170,   171,   174,   178,   181,   183,   179,
     175,  -283,  -283,  -283,  -283,  -283,  -283,  -283,  -283,  -283,
    -283,  -283,  -283,  -283,  -283,  -283,  -283,  -283,  -283,  -283,
    -283,   180,   182,   184,   185,   186,   188,   187,  -283,   189,
     190,  -283,   191,   192,   173,   194,   193,   198,   197,   195,
    -283,  -283,  -283,  -283,  -283,  -283,  -283,   204,   205,   207,
     208,   209,   210,   211,  -283,   142,  -283,   212,  -283,   143,
     213,   214,  -283,    72,  -283,   215,   216,   217,   219,   220,
    -283,   -26,  -283,   161,  -283,  -283,   162,  -283,   218,  -283,
     177,  -283,   221,  -283,   102,  -283,   222,   224,  -283,  -283,
    -283,  -283,  -283,   170,  -283,   225,  -283,    10,   226,   175,
    -283,  -283,  -283,  -283,  -283,  -283,   227,   190,   192,    35,
     193,    41,   195,  -283,  -283,  -283,   143,   206,   228,   229,
     230,   231,   223,   236,   244,  -283,   -26,  -283,  -283,   233,
     234,   235,   237,   239,   240,  -283,   241,   242,   243,   245,
     247,   248,  -283,  -283,   232,   246,   254,   255,   256,  -283,
      10,   257,   251,   238,  -283,   259,   260,   261,   262,  -283,
      35,   263,   264,   265,   266,  -283,    41,  -283,  -283,   267,
    -283,  -283,  -283,   268,   269,  -283,   244,  -283,  -283,  -283,
    -283,  -283,  -283,   270,  -283,  -283,  -283,  -283,  -283,   273,
     272,    10,    12,   238,    35,    41,  -283,  -283,   271,   274,
     276,   277,  -283,  -283,  -283,   279,   283,  -283,    12,  -283,
    -283,   281,  -283,    12,  -283
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -283,    11,  -283,  -283,   109,   111,  -283,  -283,   -97,  -283,
    -283,  -283,  -159,  -196,  -283,  -283,   -31,  -216,  -283,  -283,
    -282,  -155,  -283,  -283,   -70,   -84,  -283,  -160,  -176,  -283,
    -174,  -194,  -149,  -283,  -283,  -283,  -106,   196,  -283,  -283,
     -36,   -68,  -283,  -283,   -27,   -35,  -283,  -283,   -25,    -5,
    -283,  -111,     9,  -283,  -283,     7,    73,  -283,   -75,    17,
    -283,  -283,   249,   172,  -283,  -283,   250,   314,  -283,  -283,
     253,   328
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint16 yytable[] =
{
       1,     2,     3,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    14,    23,
     250,   251,   252,   253,   254,   255,   231,   232,   233,   234,
     235,    93,    94,    95,    96,    42,    43,    44,    45,    46,
      97,   327,   328,   329,   330,   331,   211,   212,   213,   214,
     215,   408,   409,    15,     4,     5,    47,    48,    49,    50,
      51,    52,     6,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,   339,   340,   341,   342,    16,    71,   346,   347,   348,
     349,    17,    18,    19,    22,    24,    25,    26,   106,    34,
      27,    28,    37,    31,    29,    30,   303,   325,   206,   208,
     353,   105,   138,   108,   109,    21,   112,   117,   113,   407,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     139,   140,   141,   148,   142,   143,   144,   145,   146,   147,
     257,   116,   333,   247,   149,   150,   151,   152,   153,   154,
     155,   156,   180,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   169,   168,   170,   171,   172,   173,
     174,   176,   178,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   309,   201,   204,   207,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   244,   238,   241,   335,   403,   412,   411,   424,
     364,   264,   288,   258,   259,   260,   261,   262,   263,   267,
     265,   268,   269,   270,   271,   273,   272,   317,   275,   337,
     276,   281,   277,   278,   279,   280,   282,   292,   285,   318,
     283,   289,   286,   290,   293,   294,   296,   297,   298,   299,
     300,   301,   302,   304,   354,   308,   310,   311,   312,   307,
     313,   314,   361,   338,   319,   320,   323,   321,   324,   326,
     359,   336,   334,   413,   377,   345,   355,   356,   357,   358,
     360,   365,   366,   367,   370,   368,   369,   378,   386,   371,
     372,   373,   376,   374,   375,   379,   380,   381,   385,   384,
     388,   389,   390,   391,   394,   395,   396,   397,   344,   352,
     414,    36,   401,   406,   404,   402,   400,   405,   351,   415,
     419,   418,   416,   417,   420,   423,    39,   256,     0,     0,
       0,     0,     0,     0,     0,   175,     0,     0,     0,   237,
       0,   177,     0,     0,     0,     0,     0,   322,   179
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-283)))

#define yytable_value_is_error(Yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
       3,     4,     5,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    62,     8,
     169,   170,   171,   172,   173,   174,    52,    53,    54,    55,
      56,    41,    42,    43,    44,    24,    25,    26,    27,    28,
      50,    31,    32,    33,    34,    35,   143,   144,   145,   146,
     147,    39,    40,    62,    57,    58,     6,     7,     8,     9,
      10,    11,    65,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    46,    47,    48,    49,    66,    36,    46,    47,    48,
      49,    66,    66,    59,     0,    64,    64,    64,    70,    59,
      64,    64,    59,    61,    66,    66,   265,   303,   139,    37,
     326,    67,    66,    68,    67,     6,    68,    68,    67,   401,
      68,    68,    68,    68,    68,    68,    68,    68,    68,    68,
      68,    68,    68,    68,    68,    68,    68,    68,    68,    68,
      66,    62,    66,    68,    67,    64,    64,    64,    64,    64,
      70,    40,   307,    51,    68,    68,    68,    68,    68,    68,
      68,    68,    61,    68,    68,    68,    68,    68,    68,    66,
      66,    66,    66,    66,    64,    67,    64,    64,    64,    64,
      64,    62,    62,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,   273,    62,    62,    62,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    45,    62,    62,   309,   386,   403,   402,   423,
     336,    67,    59,    70,    69,    69,    69,    69,    69,    68,
      70,    67,    64,    62,    61,    70,    67,   283,    68,   317,
      68,    64,    68,    68,    68,    67,    67,    59,    67,   286,
      70,    67,    70,    70,    67,    70,    62,    62,    61,    61,
      61,    61,    61,    61,    68,    61,    61,    61,    61,    66,
      61,    61,    38,   318,    66,   290,    64,    66,    64,    64,
      67,    64,    66,   404,    62,   320,    68,    68,    68,    68,
      64,    68,    68,    68,    64,    68,    67,    61,    70,    68,
      68,    68,    64,    68,    67,    61,    61,    61,    67,    62,
      61,    61,    61,    61,    61,    61,    61,    61,   319,   322,
     405,    17,    64,    61,    64,    66,    69,    64,   321,    68,
      61,    64,    68,    67,    61,    64,    18,   175,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   106,    -1,    -1,    -1,   163,
      -1,   111,    -1,    -1,    -1,    -1,    -1,   294,   115
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     5,    57,    58,    65,    72,    73,    77,
      78,   131,   135,   139,    62,    62,    66,    66,    66,    59,
      74,    75,     0,    72,    64,    64,    64,    64,    64,    66,
      66,    61,   132,   133,    59,   136,   138,    59,   140,   142,
      75,    76,    72,    72,    72,    72,    72,     6,     7,     8,
       9,    10,    11,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    36,    79,    80,    81,    85,    89,    93,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    41,    42,    43,    44,    50,   103,   104,
     105,   109,   113,   117,   124,    67,    70,   134,    68,    67,
     137,   138,    68,    67,   141,   142,    76,    68,    68,    68,
      68,    68,    68,    68,    68,    68,    68,    68,    68,    68,
      68,    68,    68,    68,    68,    68,    68,    68,    66,    66,
      62,    66,    67,    64,    64,    64,    64,    64,    68,    68,
      68,    68,    68,    68,    68,    68,    68,    68,    68,    68,
      68,    68,    68,    66,    66,    66,    66,    66,    67,    64,
      64,    64,    64,    64,    64,   133,    62,   137,    62,   141,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    62,    82,    83,    62,    86,    87,    62,    37,    94,
      95,    79,    79,    79,    79,    79,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    52,    53,    54,    55,    56,   106,   108,    62,   110,
     111,    62,   114,   115,    45,   118,   120,    51,   125,   127,
     103,   103,   103,   103,   103,   103,   134,    70,    70,    69,
      69,    69,    69,    69,    67,    70,    84,    68,    67,    64,
      62,    61,    67,    70,    96,    68,    68,    68,    68,    68,
      67,    64,    67,    70,   112,    67,    70,   116,    59,    67,
      70,   119,    59,    67,    70,   126,    62,    62,    61,    61,
      61,    61,    61,    83,    61,    87,    88,    66,    61,    95,
      61,    61,    61,    61,    61,   107,   108,   111,   115,    66,
     120,    66,   127,    64,    64,    84,    64,    31,    32,    33,
      34,    35,    90,    92,    66,    96,    64,   112,   116,    46,
      47,    48,    49,   121,   123,   119,    46,    47,    48,    49,
     128,   130,   126,    88,    68,    68,    68,    68,    68,    67,
      64,    38,    97,    98,   107,    68,    68,    68,    68,    67,
      64,    68,    68,    68,    68,    67,    64,    62,    61,    61,
      61,    61,    91,    92,    62,    67,    70,    99,    61,    61,
      61,    61,   122,   123,    61,    61,    61,    61,   129,   130,
      69,    64,    66,    98,    64,    64,    61,    91,    39,    40,
     100,   101,    99,   122,   129,    68,    68,    67,    64,    61,
      61,   101,   102,    64,   102
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 9:
/* Line 1792 of yacc.c  */
#line 514 "race-class.y"
    {/*don't do anything*/;}
    break;

  case 11:
/* Line 1792 of yacc.c  */
#line 521 "race-class.y"
    {/* don't do anything with it*/;}
    break;

  case 14:
/* Line 1792 of yacc.c  */
#line 529 "race-class.y"
    { tmpRace.val.r.trace =
				    (char *) malloc(strlen((yyvsp[(2) - (5)].sval)) + 1);
				  strcpy(tmpRace.val.r.trace, (yyvsp[(2) - (5)].sval));
                                  tmpRace.idx = St_TableSize(raceT_P);
				  PutRace((yyvsp[(2) - (5)].sval), &tmpRace,
					      arguments.rcc.consistency_check);
				  tmpRace = blankRace;
				}
    break;

  case 15:
/* Line 1792 of yacc.c  */
#line 540 "race-class.y"
    { tmpClass.val.c.title =
				    (char *) malloc(strlen((yyvsp[(2) - (5)].sval)) + 1);
				  strcpy(tmpClass.val.c.title, (yyvsp[(2) - (5)].sval));
                                  tmpClass.idx = St_TableSize(classT_P);
				  PutClass((yyvsp[(2) - (5)].sval), &tmpClass,
					      arguments.rcc.consistency_check);
				  tmpClass = blankClass;
				}
    break;

  case 22:
/* Line 1792 of yacc.c  */
#line 559 "race-class.y"
    { tmpRace.val.r.b_age = (yyvsp[(3) - (5)].ival);
                                  tmpRace.val.r.m_age = (yyvsp[(5) - (5)].ival);
				  tmpRace.def.age = TRUE; }
    break;

  case 23:
/* Line 1792 of yacc.c  */
#line 563 "race-class.y"
    { tmpRace.val.r.infra = (yyvsp[(3) - (3)].ival);
				  tmpRace.def.infra_vision = TRUE; }
    break;

  case 24:
/* Line 1792 of yacc.c  */
#line 566 "race-class.y"
    { tmpRace.val.r.m_b_ht = (yyvsp[(3) - (5)].ival);
				  tmpRace.val.r.m_m_ht = (yyvsp[(5) - (5)].ival);
				  tmpRace.def.male_height = TRUE; }
    break;

  case 25:
/* Line 1792 of yacc.c  */
#line 570 "race-class.y"
    { tmpRace.val.r.m_b_wt = (yyvsp[(3) - (5)].ival);
				  tmpRace.val.r.m_m_wt = (yyvsp[(5) - (5)].ival);
				  tmpRace.def.male_weight = TRUE; }
    break;

  case 26:
/* Line 1792 of yacc.c  */
#line 574 "race-class.y"
    { tmpRace.val.r.f_b_ht = (yyvsp[(3) - (5)].ival);
				  tmpRace.val.r.f_m_ht = (yyvsp[(5) - (5)].ival);
				  tmpRace.def.female_height = TRUE; }
    break;

  case 27:
/* Line 1792 of yacc.c  */
#line 578 "race-class.y"
    { tmpRace.val.r.f_b_wt = (yyvsp[(3) - (5)].ival);
				  tmpRace.val.r.f_m_wt = (yyvsp[(5) - (5)].ival);
				  tmpRace.def.female_weight = TRUE; }
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 582 "race-class.y"
    { tmpRace.val.r.bhitdie = (yyvsp[(3) - (3)].ival);
				  tmpRace.def.hit_points = TRUE; }
    break;

  case 29:
/* Line 1792 of yacc.c  */
#line 585 "race-class.y"
    { tmpRace.val.r.b_dis = (yyvsp[(3) - (3)].ival);
				  tmpRace.def.disarming = TRUE; }
    break;

  case 30:
/* Line 1792 of yacc.c  */
#line 588 "race-class.y"
    { tmpRace.val.r.srh = (yyvsp[(3) - (3)].ival);
				  tmpRace.def.search_chance = TRUE; }
    break;

  case 31:
/* Line 1792 of yacc.c  */
#line 591 "race-class.y"
    { tmpRace.val.r.stl = (yyvsp[(3) - (3)].ival);
				  tmpRace.def.stealth_factor = TRUE; }
    break;

  case 32:
/* Line 1792 of yacc.c  */
#line 594 "race-class.y"
    { tmpRace.val.r.fos = (yyvsp[(3) - (3)].ival);
				  tmpRace.def.frequency_of_search = TRUE; }
    break;

  case 33:
/* Line 1792 of yacc.c  */
#line 597 "race-class.y"
    { tmpRace.val.r.bth = (yyvsp[(3) - (3)].ival);
				  tmpRace.def.base_to_hit = TRUE; }
    break;

  case 34:
/* Line 1792 of yacc.c  */
#line 600 "race-class.y"
    { tmpRace.val.r.bthb = (yyvsp[(3) - (3)].ival);
				  tmpRace.def.base_to_hit_with_bows = TRUE; }
    break;

  case 35:
/* Line 1792 of yacc.c  */
#line 603 "race-class.y"
    { tmpRace.val.r.bsav = (yyvsp[(3) - (3)].ival);
				  tmpRace.def.saving_throw = TRUE; }
    break;

  case 36:
/* Line 1792 of yacc.c  */
#line 606 "race-class.y"
    { tmpRace.val.r.str_adj = (yyvsp[(3) - (3)].ival);
				  tmpRace.def.strength_modifier = TRUE; }
    break;

  case 37:
/* Line 1792 of yacc.c  */
#line 609 "race-class.y"
    { tmpRace.val.r.int_adj = (yyvsp[(3) - (3)].ival);
				  tmpRace.def.intelligence_modifier = TRUE; }
    break;

  case 38:
/* Line 1792 of yacc.c  */
#line 612 "race-class.y"
    { tmpRace.val.r.wis_adj = (yyvsp[(3) - (3)].ival);
				  tmpRace.def.wisdom_modifier = TRUE; }
    break;

  case 39:
/* Line 1792 of yacc.c  */
#line 615 "race-class.y"
    { tmpRace.val.r.dex_adj = (yyvsp[(3) - (3)].ival);
				  tmpRace.def.dexterity_modifier = TRUE; }
    break;

  case 40:
/* Line 1792 of yacc.c  */
#line 618 "race-class.y"
    { tmpRace.val.r.con_adj = (yyvsp[(3) - (3)].ival);
				  tmpRace.def.constitution_modifier = TRUE; }
    break;

  case 41:
/* Line 1792 of yacc.c  */
#line 621 "race-class.y"
    { tmpRace.val.r.chr_adj = (yyvsp[(3) - (3)].ival);
				  tmpRace.def.charisma_modifier = TRUE; }
    break;

  case 42:
/* Line 1792 of yacc.c  */
#line 624 "race-class.y"
    { tmpRace.val.r.b_exp = (yyvsp[(3) - (3)].ival);
				  tmpRace.def.experience_factor = TRUE; }
    break;

  case 43:
/* Line 1792 of yacc.c  */
#line 629 "race-class.y"
    { /*PutAllowedClassesForRace();*/ 
                                  tmpRace.def.classes = TRUE; 
                                  tmpRace.line_no_for_classes = lineNo;}
    break;

  case 45:
/* Line 1792 of yacc.c  */
#line 638 "race-class.y"
    { argz_add(&tmpRace.val.classes_argz,
                                           &tmpRace.val.classes_len, (yyvsp[(1) - (1)].sval));}
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 647 "race-class.y"
    {tmpRace.def.store_price_adjust_by_race = TRUE;
                                 tmpRace.line_no_for_price_adjust = lineNo; }
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 655 "race-class.y"
    {if (arguments.rcc.consistency_check)
                                   {
                                     int i = 0;
                                     for (; i<tmpRace.val.num_price_adjust; i++)
                                       {
                                         race_price_t val =
                                           tmpRace.val.price_adjust[i];
                                         if (strcmp (val.race, (yyvsp[(1) - (3)].sval)) == 0)
                                           {
                                             char *msg = 
                                               xasprintf ("duplicate race `%s'",
                                                           val.race);
                                             yyerror (msg);
                                           }
                                       }
                                       if ((yyvsp[(3) - (3)].ival) == 0)
                                         {
                                           char *msg = "price must be greater "
                                                       "than zero";
                                           yyerror (msg);
                                         }
                                   }
                                 tmpRace.val.num_price_adjust++;
                                 int num = tmpRace.val.num_price_adjust;
                                 tmpRace.val.price_adjust = 
                                   realloc (tmpRace.val.price_adjust,
                                            num * sizeof (race_price_t));
                                 race_price_t val;
                                 val.race = strdup((yyvsp[(1) - (3)].sval)); //FIXME leak
                                 val.price = (yyvsp[(3) - (3)].ival);
                                 tmpRace.val.price_adjust[num-1] = val;}
    break;

  case 53:
/* Line 1792 of yacc.c  */
#line 693 "race-class.y"
    { 
                                  tmpRace.def.shopkeep = TRUE;
                                  char *r = xasprintf ("(%s)", (yyvsp[(3) - (7)].sval));
                                  tmpShopkeep.val.owner_name = 
                                    xasprintf ("%-22s %-12s %s", 
                                      (yyvsp[(2) - (7)].sval), r, (yyvsp[(4) - (7)].sval));
                                  tmpShopkeep.line_no = lineNo;
                                  tmpShopkeep.val.owner_race = 
                                    St_TableSize(raceT_P);
				  PutShopkeep(&tmpShopkeep,
					      arguments.rcc.consistency_check);
				  tmpShopkeep = blankShopkeep;
                                  num_shopkeeps++;
				}
    break;

  case 57:
/* Line 1792 of yacc.c  */
#line 717 "race-class.y"
    {
                                 if (arguments.rcc.consistency_check)
                                   {
                                     if (strlen ((yyvsp[(3) - (3)].sval)) > 1 || 
                                         strlen ((yyvsp[(3) - (3)].sval)) == 0 ||
                                         (yyvsp[(3) - (3)].sval)[0] - '1' > MAX_STORES)
                                       yyerror ("invalid store");
                                   }
                                 tmpShopkeep.def.store = TRUE;
                                 tmpShopkeep.val.pstore = (yyvsp[(3) - (3)].sval)[0] - '1';}
    break;

  case 58:
/* Line 1792 of yacc.c  */
#line 728 "race-class.y"
    {tmpShopkeep.def.haggle_per = TRUE;
                                 tmpShopkeep.val.haggle_per = (yyvsp[(3) - (3)].ival);}
    break;

  case 59:
/* Line 1792 of yacc.c  */
#line 731 "race-class.y"
    {tmpShopkeep.def.inflate = TRUE;
                                 tmpShopkeep.val.min_inflate = (yyvsp[(3) - (5)].ival);
                                 tmpShopkeep.val.max_inflate = 
                                   tmpShopkeep.val.min_inflate + (yyvsp[(5) - (5)].ival);}
    break;

  case 60:
/* Line 1792 of yacc.c  */
#line 736 "race-class.y"
    {tmpShopkeep.def.max_insults = TRUE;
                                 tmpShopkeep.val.insult_max = (yyvsp[(3) - (3)].ival);}
    break;

  case 61:
/* Line 1792 of yacc.c  */
#line 739 "race-class.y"
    {tmpShopkeep.def.max_cost = TRUE;
                                 tmpShopkeep.val.max_cost = (yyvsp[(3) - (3)].ival);}
    break;

  case 62:
/* Line 1792 of yacc.c  */
#line 744 "race-class.y"
    {tmpRace.def.backgrounds = TRUE;}
    break;

  case 64:
/* Line 1792 of yacc.c  */
#line 751 "race-class.y"
    {int i;
                                 for (i=0; i<tmpRace.val.num_backgrounds; i++)
                                   if (!tmpRace.val.backgrounds[i].chart)
                                     {
                                       tmpRace.val.backgrounds[i].chart = 
                                         (yyvsp[(2) - (6)].ival);
                                       tmpRace.val.backgrounds[i].next = 
                                         (yyvsp[(3) - (6)].ival);
                                     }
                                 if (arguments.rcc.consistency_check)
                                   CheckBackground((yyvsp[(2) - (6)].ival), (yyvsp[(3) - (6)].ival)); }
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 772 "race-class.y"
    {tmpBackground.val.info = strdup((yyvsp[(2) - (5)].sval));
                                 //FIXME leak
                                 PutBackground(&tmpBackground,
                                               arguments.rcc.consistency_check);
                                 tmpBackground = blankBackground;}
    break;

  case 72:
/* Line 1792 of yacc.c  */
#line 787 "race-class.y"
    {if (arguments.rcc.consistency_check &&
                                     (yyvsp[(3) - (3)].ival) > 100)
                                   yyerror("roll exceeds 100");
                                 tmpBackground.def.roll = TRUE;
                                 tmpBackground.val.roll = (yyvsp[(3) - (3)].ival);}
    break;

  case 73:
/* Line 1792 of yacc.c  */
#line 793 "race-class.y"
    {tmpBackground.def.social_class_bonus = TRUE;
                                 tmpBackground.val.bonus = (yyvsp[(3) - (3)].ival);}
    break;

  case 83:
/* Line 1792 of yacc.c  */
#line 811 "race-class.y"
    { tmpClass.val.c.adj_hd = (yyvsp[(3) - (3)].ival);
				  tmpClass.def.hit_points = TRUE; }
    break;

  case 84:
/* Line 1792 of yacc.c  */
#line 814 "race-class.y"
    { tmpClass.val.c.mdis = (yyvsp[(3) - (3)].ival);
				  tmpClass.def.disarming = TRUE; }
    break;

  case 85:
/* Line 1792 of yacc.c  */
#line 817 "race-class.y"
    { tmpClass.val.c.msrh = (yyvsp[(3) - (3)].ival);
				  tmpClass.def.search_chance = TRUE; }
    break;

  case 86:
/* Line 1792 of yacc.c  */
#line 820 "race-class.y"
    { tmpClass.val.c.mstl = (yyvsp[(3) - (3)].ival);
				  tmpClass.def.stealth_factor = TRUE; }
    break;

  case 87:
/* Line 1792 of yacc.c  */
#line 823 "race-class.y"
    { tmpClass.val.c.mfos = (yyvsp[(3) - (3)].ival);
				  tmpClass.def.frequency_of_search = TRUE; }
    break;

  case 88:
/* Line 1792 of yacc.c  */
#line 826 "race-class.y"
    { tmpClass.val.c.mbth = (yyvsp[(3) - (3)].ival);
				  tmpClass.def.base_to_hit = TRUE; }
    break;

  case 89:
/* Line 1792 of yacc.c  */
#line 829 "race-class.y"
    { tmpClass.val.c.mbthb = (yyvsp[(3) - (3)].ival);
				  tmpClass.def.base_to_hit_with_bows = TRUE; }
    break;

  case 90:
/* Line 1792 of yacc.c  */
#line 832 "race-class.y"
    { tmpClass.val.c.msav = (yyvsp[(3) - (3)].ival);
				  tmpClass.def.saving_throw = TRUE; }
    break;

  case 91:
/* Line 1792 of yacc.c  */
#line 835 "race-class.y"
    { tmpClass.val.c.madj_str = (yyvsp[(3) - (3)].ival);
				  tmpClass.def.strength_modifier = TRUE; }
    break;

  case 92:
/* Line 1792 of yacc.c  */
#line 838 "race-class.y"
    { tmpClass.val.c.madj_int = (yyvsp[(3) - (3)].ival);
				  tmpClass.def.intelligence_modifier = TRUE; }
    break;

  case 93:
/* Line 1792 of yacc.c  */
#line 841 "race-class.y"
    { tmpClass.val.c.madj_wis = (yyvsp[(3) - (3)].ival);
				  tmpClass.def.wisdom_modifier = TRUE; }
    break;

  case 94:
/* Line 1792 of yacc.c  */
#line 844 "race-class.y"
    { tmpClass.val.c.madj_dex = (yyvsp[(3) - (3)].ival);
				  tmpClass.def.dexterity_modifier = TRUE; }
    break;

  case 95:
/* Line 1792 of yacc.c  */
#line 847 "race-class.y"
    { tmpClass.val.c.madj_con = (yyvsp[(3) - (3)].ival);
				  tmpClass.def.constitution_modifier = TRUE; }
    break;

  case 96:
/* Line 1792 of yacc.c  */
#line 850 "race-class.y"
    { tmpClass.val.c.madj_chr = (yyvsp[(3) - (3)].ival);
				  tmpClass.def.charisma_modifier = TRUE; }
    break;

  case 97:
/* Line 1792 of yacc.c  */
#line 853 "race-class.y"
    { tmpClass.val.c.m_exp = (yyvsp[(3) - (3)].ival);
				  tmpClass.def.experience_factor = TRUE; }
    break;

  case 102:
/* Line 1792 of yacc.c  */
#line 868 "race-class.y"
    {tmpClass.val.adjust_per_one_third_level[0] =
                                 (yyvsp[(3) - (3)].ival);
                                 tmpClass.def.adjust_base_to_hit = TRUE;}
    break;

  case 103:
/* Line 1792 of yacc.c  */
#line 872 "race-class.y"
    {tmpClass.val.adjust_per_one_third_level[1] =
                                 (yyvsp[(3) - (3)].ival);
                                 tmpClass.def.adjust_base_to_hit_with_bows = TRUE;}
    break;

  case 104:
/* Line 1792 of yacc.c  */
#line 876 "race-class.y"
    {tmpClass.val.adjust_per_one_third_level[2] =
                                 (yyvsp[(3) - (3)].ival);
                                 tmpClass.def.adjust_use_device = TRUE;}
    break;

  case 105:
/* Line 1792 of yacc.c  */
#line 880 "race-class.y"
    {tmpClass.val.adjust_per_one_third_level[3] =
                                 (yyvsp[(3) - (3)].ival);
                                 tmpClass.def.adjust_disarming = TRUE;}
    break;

  case 106:
/* Line 1792 of yacc.c  */
#line 884 "race-class.y"
    {tmpClass.val.adjust_per_one_third_level[4] =
                                 (yyvsp[(3) - (3)].ival);
                                 tmpClass.def.adjust_saving_throw = TRUE;}
    break;

  case 107:
/* Line 1792 of yacc.c  */
#line 890 "race-class.y"
    { /*PutTitles();*/ }
    break;

  case 109:
/* Line 1792 of yacc.c  */
#line 897 "race-class.y"
    { 
                                 if (arguments.rcc.consistency_check)
                                   {
                                     const char *t = NULL;
                                     char *argz = tmpClass.val.male_titles_argz;
                                     size_t len = tmpClass.val.male_titles_len;
                                     while ((t = argz_next (argz, len, t)))
                                       {
                                         if (strcmp (t, (yyvsp[(1) - (1)].sval)) == 0)
                                           {
                                             char *msg = 
                                               xasprintf ("duplicate title %s",
                                                          (yyvsp[(1) - (1)].sval));
                                             yyerror (msg);
                                           }
                                       }
                                   }

                                 argz_add (&tmpClass.val.male_titles_argz,
                                           &tmpClass.val.male_titles_len, 
                                           (yyvsp[(1) - (1)].sval)); }
    break;

  case 112:
/* Line 1792 of yacc.c  */
#line 925 "race-class.y"
    { /*PutTitles();*/ }
    break;

  case 114:
/* Line 1792 of yacc.c  */
#line 932 "race-class.y"
    { 
                                 if (arguments.rcc.consistency_check)
                                   {
                                     const char *t = NULL;
                                     char *argz = 
                                       tmpClass.val.female_titles_argz;
                                     size_t len = 
                                       tmpClass.val.female_titles_len;
                                     while ((t = argz_next (argz, len, t)))
                                       {
                                         if (strcmp (t, (yyvsp[(1) - (1)].sval)) == 0)
                                           {
                                             char *msg = 
                                               xasprintf ("duplicate title %s",
                                                          (yyvsp[(1) - (1)].sval));
                                             yyerror (msg);
                                           }
                                       }
                                   }

                                 argz_add (&tmpClass.val.female_titles_argz,
                                           &tmpClass.val.female_titles_len, 
                                           (yyvsp[(1) - (1)].sval)); }
    break;

  case 121:
/* Line 1792 of yacc.c  */
#line 972 "race-class.y"
    {PutSpell((yyvsp[(2) - (5)].sval), &tmpSpell,
                                          arguments.rcc.consistency_check);
                                 tmpSpell = blankSpell;}
    break;

  case 125:
/* Line 1792 of yacc.c  */
#line 985 "race-class.y"
    {tmpSpell.val.s.slevel = (yyvsp[(3) - (3)].ival);
                                 tmpSpell.def.level = TRUE;}
    break;

  case 126:
/* Line 1792 of yacc.c  */
#line 988 "race-class.y"
    {tmpSpell.val.s.smana = (yyvsp[(3) - (3)].ival);
                                 tmpSpell.def.mana = TRUE;}
    break;

  case 127:
/* Line 1792 of yacc.c  */
#line 991 "race-class.y"
    {tmpSpell.val.s.sfail = (yyvsp[(3) - (3)].ival);
                                 tmpSpell.def.fail = TRUE;}
    break;

  case 128:
/* Line 1792 of yacc.c  */
#line 994 "race-class.y"
    {tmpSpell.val.s.sexp = (yyvsp[(3) - (3)].ival);
                                 tmpSpell.def.exp = TRUE;}
    break;

  case 133:
/* Line 1792 of yacc.c  */
#line 1009 "race-class.y"
    {PutPrayer((yyvsp[(2) - (5)].sval), &tmpPrayer,
                                           arguments.rcc.consistency_check);
                                 tmpPrayer = blankPrayer;}
    break;

  case 137:
/* Line 1792 of yacc.c  */
#line 1022 "race-class.y"
    {tmpPrayer.val.s.slevel = (yyvsp[(3) - (3)].ival);
                                 tmpPrayer.def.level = TRUE;}
    break;

  case 138:
/* Line 1792 of yacc.c  */
#line 1025 "race-class.y"
    {tmpPrayer.val.s.smana = (yyvsp[(3) - (3)].ival);
                                 tmpPrayer.def.mana = TRUE;}
    break;

  case 139:
/* Line 1792 of yacc.c  */
#line 1028 "race-class.y"
    {tmpPrayer.val.s.sfail = (yyvsp[(3) - (3)].ival);
                                 tmpPrayer.def.fail = TRUE;}
    break;

  case 140:
/* Line 1792 of yacc.c  */
#line 1031 "race-class.y"
    {tmpPrayer.val.s.sexp = (yyvsp[(3) - (3)].ival);
                                 tmpPrayer.def.exp = TRUE;}
    break;

  case 143:
/* Line 1792 of yacc.c  */
#line 1042 "race-class.y"
    { 
                                  int lvl = num_experience_levels;
                                  if (lvl > 0 &&
                                      experience_levels[lvl-1] > (yyvsp[(1) - (1)].ival) &&
                                      arguments.rcc.consistency_check)
                                    yyerror (xasprintf("%s %d is too small",
                                                       "experience level",
                                                       (yyvsp[(1) - (1)].ival)));
                                  else
                                    {
                                      num_experience_levels++;
                                      lvl++;
                                      experience_levels =
                                        realloc (experience_levels, lvl * 
                                                   sizeof (int));
                                      experience_levels[lvl-1] = (yyvsp[(1) - (1)].ival);
                                    }
                                }
    break;

  case 150:
/* Line 1792 of yacc.c  */
#line 1077 "race-class.y"
    { PutSpellInfo ((yyvsp[(2) - (6)].sval), (yyvsp[(3) - (6)].sval), (yyvsp[(5) - (6)].sval),
                                         arguments.rcc.consistency_check);
                         }
    break;

  case 155:
/* Line 1792 of yacc.c  */
#line 1093 "race-class.y"
    { PutPrayerInfo ((yyvsp[(2) - (6)].sval), (yyvsp[(3) - (6)].sval), (yyvsp[(5) - (6)].sval),
                                         arguments.rcc.consistency_check);
                         }
    break;


/* Line 1792 of yacc.c  */
#line 2930 "race-class.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 1097 "race-class.y"




/*
 * MyFGetC--
 *	fgetc with support for comments
 *
 *	# is the comment character.  comment lasts till end of line.
 * Spews out an extra char of whitespace at EOF since something seems to
 * need it.  I'll figure this out eventually...
 */
static int 
MyFGetC (FILE *input_F)
{
  while (!*inputBufp || (*inputBufp == '#')) 
    {
      fgets (inputBuf, INPUT_BUF_SIZE, input_F);
      if (feof (input_F))
	return EOF;
      lineNo++;
      inputBufp = inputBuf;
    }
  return *inputBufp++;
}



/*
 * Advance--
 *	Advance to the next token in the input stream and set tokStr,
 * tokType.
 *
 *	On error, tokType is set to a negative value.
 */
static void 
Advance (FILE *input_F)
{
  register char *tok = tokStr;	/* accumulating token string		    */
  register int len = 0;		/* length of current token		    */
  static int c = 32;		/* current character; ' ' is harmless init  */


  /*
   * Skip whitespace in the stream
   */
  while ((c != EOF) && isspace (c))
    c = MyFGetC (input_F);

  /*
   * At end of file?
   */
  if (c == EOF) 
    {
      tokType = EOF;
      strcpy (tokStr, "[EOF]");
      return;
    }

  /*
   * Recognize a number [+|-][dddd][.][dddd][{e|E}[+|-]dddd]
   */
  if (isdigit (c) || (c == '.') || (c == '+') || (c == '-')) 
    {
      register int decPt = FALSE,   /* seen a decimal point yet?	*/
	       hasExp = FALSE;	    /* has an exponent?			*/

      if ((c == '-') || (c == '+')) 
	{
	  *tok++ = c;
	  c = MyFGetC (input_F);
	}

      while ((len < MAX_TOK_LEN - 1) && (isdigit (c) || (c == '.'))) 
	{
	  if (c == '.') 
	    {
	      if (decPt)
		break;
	      else
		decPt = TRUE;
	    }

	  *tok++ = c;
	  c = MyFGetC (input_F);
	  len++;
	}

      if ((c == 'e') || (c == 'E')) 
	{
	  hasExp = TRUE;
	  *tok++ = c;
	  c = MyFGetC (input_F);
	  len++;

	  if ((c == '-') || (c == '+')) 
	    {
	      *tok++ = c;
	      c = MyFGetC (input_F);
	      len++;
	    }

	  while ((len < MAX_TOK_LEN - 1) && isdigit (c)) 
	    {
	      *tok++ = c;
	      c = MyFGetC (input_F);
	      len++;
	    }
	}

      *tok = 0;

      if (decPt || hasExp) 
	{
	  tokType = FLOAT_LIT;
	  yylval.dval = atof (tokStr);
	} 
      else 
	{
	  tokType = INT_LIT;
	  yylval.ival = atoi (tokStr);
	}

      return;

    }

  /*
   * Recognize a quoted string
   */
  if (c == '\"') 
    {

      c = MyFGetC (input_F);

      while ((len < MAX_TOK_LEN - 1) &&
	     (c != EOF) && (c != '\n') && (c != '\"')) 
	{
	  *tok++ = c;
	  c = MyFGetC (input_F);
	}

      *tok = 0;

      c = MyFGetC (input_F);

      tokType = STRING_LIT;
      strncpy (yylval.sval, tokStr, MAX_TOK_LEN - 1);
      yylval.sval[MAX_TOK_LEN - 1] = 0;

      return;

    }

  /*
   * Recognize an identifier and try to match it with a keyword.
   * Identifiers begin with a letter and continue in letters and/or
   * digits.  Convert it to lowercase.
   */
  if (isalpha (c) || (c == '_') || (c == '$')) {

    if (isupper (c))
      c = tolower (c);
    *tok++ = c;
    c = MyFGetC (input_F);
    len++;

    while ((len < MAX_TOK_LEN - 1) && (isalpha (c) || isdigit (c) ||
				       (c == '_') || (c == '$'))) 
      {
	if (isupper (c))
	  c = tolower (c);
	*tok++ = c;
	c = MyFGetC (input_F);
	len++;
      }

    *tok = 0;

    /*
     * We've got the identifier; see if it matches any keywords.
     */

      {
	generic_t gval;
	int type;
	if (St_GetSym (keywordT_P, tokStr, &type, &gval) == ST_SYM_FOUND) 
	  {
	    tokType = gval.i;
	    strncpy (yylval.sval, tokStr, MAX_TOK_LEN - 1);
	    yylval.sval[MAX_TOK_LEN - 1] = 0;
	  } 
	else if (!strcmp (tokStr, "true")) 
	  {
	    tokType = BOOL_LIT;
	    yylval.ival = 1;
	  } 
	else if (!strcmp (tokStr, "false")) 
	  {
	    tokType = BOOL_LIT;
	    yylval.ival = 0;
	  } 
	else 
	  {
	    tokType = IDENTIFIER;
	    strncpy (yylval.sval, tokStr, MAX_TOK_LEN - 1);
	    yylval.sval[MAX_TOK_LEN - 1] = 0;
	  }
      }

    return;

  }

  /*
   * Recognize punctuation
   */

  tokType = c;
  *tok++ = c;
  *tok = 0;
  c = MyFGetC (input_F);
  return;
}

void 
ErrMsgLineNo (char *s, int line_no)
{
  if (line_no >= 0)
    fprintf (stderr, "Error: %s at line %d\n", s, line_no);
  else
    fprintf (stderr, "Error: %s\n", s);
}

void 
ErrMsg (char *s)
{
  int i;

  fprintf (stderr, "Error: %s at line %d\n", s, lineNo);
  fprintf (stderr, "%s", inputBuf);
  for (i = 0; i < inputBufp - inputBuf; i++) 
    {
      fputc ((inputBuf[i] == '\t' ? '\t' : ' '), stderr);
    }
  fprintf (stderr, "^ before here\n\n");
  return;
}

int 
yyerror (char *s)
{
  ErrMsg (s);
  return 0;
}


int 
yylex ()
{
  Advance (input_F);
  return tokType;
}

st_Table_Pt 
InitTable (char *name, symInit_t *init)
{
  int i;
  st_Table_Pt table_P;
  generic_t gval;

  table_P = St_NewTable (name, 20);
  for (i = 0; init[i].name; i++) 
    {
      gval.i = init[i].val;
      St_DefSym (table_P, init[i].name, GEN_TYPE_INT, gval);
    }

  return table_P;
}

void 
InitTables ()
{
  keywordT_P = InitTable ("keyword", keywordInit);
  spellsT_P = InitTable ("spells", spellsInit);
  prayersT_P = InitTable ("prayers", prayersInit);

  raceT_P = St_NewTable ("race", 200);
  classT_P = St_NewTable ("class", 40);

  return;
}

void 
NotDefined(char *name, char *s)
{
  fprintf (stderr, 
	   "Warning: %s not defined for \"%s\", line %d\n",
	   s, name, lineNo);
  return;
}

void 
PutRace (char *s, race_template_t *tmpl_P, int consistency_check)
{
  generic_t gval;

  gval.v = malloc (sizeof(race_template_t));
  *(race_template_t *) gval.v = *tmpl_P;

  if (!tmpl_P->def.age)
    NotDefined (tmpl_P->val.r.trace, "AGE");
  if (!tmpl_P->def.infra_vision)
    NotDefined (tmpl_P->val.r.trace, "INFRA_VISION");
  if (!tmpl_P->def.male_height)
    NotDefined (tmpl_P->val.r.trace, "MALE_HEIGHT");
  if (!tmpl_P->def.male_weight)
    NotDefined (tmpl_P->val.r.trace, "MALE_WEIGHT");
  if (!tmpl_P->def.female_height)
    NotDefined (tmpl_P->val.r.trace, "FEMALE_HEIGHT");
  if (!tmpl_P->def.female_weight)
    NotDefined (tmpl_P->val.r.trace, "FEMALE_WEIGHT");
  if (!tmpl_P->def.hit_points)
    NotDefined (tmpl_P->val.r.trace, "HIT_POINTS");
  if (!tmpl_P->def.disarming)
    NotDefined (tmpl_P->val.r.trace, "DISARMING");
  if (!tmpl_P->def.search_chance)
    NotDefined (tmpl_P->val.r.trace, "SEARCH_CHANCE");
  if (!tmpl_P->def.stealth_factor)
    NotDefined (tmpl_P->val.r.trace, "STEALTH_FACTOR");
  if (!tmpl_P->def.frequency_of_search)
    NotDefined (tmpl_P->val.r.trace, "FREQUENCY_OF_SEARCH");
  if (!tmpl_P->def.base_to_hit)
    NotDefined (tmpl_P->val.r.trace, "BASE_TO_HIT");
  if (!tmpl_P->def.base_to_hit_with_bows)
    NotDefined (tmpl_P->val.r.trace, "BASE_TO_HIT_WITH_BOWS");
  if (!tmpl_P->def.saving_throw)
    NotDefined (tmpl_P->val.r.trace, "SAVING_THROW");
  if (!tmpl_P->def.strength_modifier)
    NotDefined (tmpl_P->val.r.trace, "STRENGTH_MODIFIER");
  if (!tmpl_P->def.intelligence_modifier)
    NotDefined (tmpl_P->val.r.trace, "INTELLIGENCE_MODIFIER");
  if (!tmpl_P->def.wisdom_modifier)
    NotDefined (tmpl_P->val.r.trace, "WISDOM_MODIFIER");
  if (!tmpl_P->def.dexterity_modifier)
    NotDefined (tmpl_P->val.r.trace, "DEXTERITY_MODIFIER");
  if (!tmpl_P->def.constitution_modifier)
    NotDefined (tmpl_P->val.r.trace, "CONSTITUTION_MODIFIER");
  if (!tmpl_P->def.charisma_modifier)
    NotDefined (tmpl_P->val.r.trace, "CHARISMA_MODIFIER");
  if (!tmpl_P->def.experience_factor)
    NotDefined (tmpl_P->val.r.trace, "EXPERIENCE_FACTOR");
  if (!tmpl_P->def.classes)
    NotDefined (tmpl_P->val.r.trace, "CLASSES");
  if (!tmpl_P->def.store_price_adjust_by_race)
    NotDefined (tmpl_P->val.r.trace, "STORE_PRICE_ADJUST_BY_RACE");
  if (!tmpl_P->def.shopkeep)
    ;//NotDefined (tmpl_P->val.r.trace, ""); it's okay if we don't have one.
  if (!tmpl_P->def.backgrounds)
    NotDefined (tmpl_P->val.r.trace, "BACKGROUNDS");

  if (consistency_check)
    ;//ConsistencyCheckRace (&tmpl_P->val, &tmpl_P->state);

  if (St_DefSym (raceT_P, s, GEN_TYPE_TMPL, gval) == ST_SYM_FOUND) 
    {
      fprintf (arguments.rcc.outfile, "Warning: redefining \"%s\", line %d\n", 
               tmpl_P->val.r.trace, lineNo);
    }

  return;
}

void PutShopkeep(shopkeep_template_t *tmpl_P, int consistency_check)
{
  char *id = "shopkeep";
  if (!tmpl_P->def.store)
    NotDefined (id, "STORE");
  if (!tmpl_P->def.haggle_per)
    NotDefined (id, "HAGGLE_PER");
  if (!tmpl_P->def.inflate)
    NotDefined (id, "INFLATE");
  if (!tmpl_P->def.max_insults)
    NotDefined (id, "MAX_INSULTS");
  if (!tmpl_P->def.max_cost)
    NotDefined (id, "MAX_COST");
  if (consistency_check)
    {
      if (tmpl_P->val.insult_max == 0)
        yyerror ("max_insults can't be zero");
      if (tmpl_P->val.max_cost == 0)
        yyerror ("max_cost can't be zero");
    }
  tmpRace.val.num_shopkeeps++;
  tmpRace.val.shopkeeps = realloc(tmpRace.val.shopkeeps, 
                                  tmpRace.val.num_shopkeeps * 
                                    sizeof(owner_type));
  tmpRace.val.shopkeeps[tmpRace.val.num_shopkeeps-1] = tmpl_P->val;
}

void PutBackground(background_template_t *tmpl_P, int consistency_check)
{
  if (!tmpl_P->def.roll)
    NotDefined("fragment", "ROLL");
  if (!tmpl_P->def.social_class_bonus)
    NotDefined("fragment", "SOCIAL_CLASS_BONUS");
  tmpRace.val.num_backgrounds++;
  int num = tmpRace.val.num_backgrounds;
  tmpRace.val.backgrounds = realloc (tmpRace.val.backgrounds, 
                                     num * sizeof (background_type));
  tmpRace.val.backgrounds[num-1] = tmpBackground.val;
}

void CheckSpell (spell_type *s)
{
  if (s->slevel == 0)
    yyerror ("level can't be zero");
  if (s->smana == 0)
    yyerror ("mana can't be zero");
  if (s->sfail >= 100)
    yyerror ("fail can't be 100 or more");
}

void
PutSpell (char *s, spell_template_t *tmpl_P, int consistency_check)
{
  generic_t gval;
  int type;
  if (St_GetSym (spellsT_P, s, &type, &gval) != ST_SYM_FOUND) 
    {
      yyerror (xasprintf("unknown spell `%s'", s));
      return;
    }
  tmpl_P->val.idx = gval.i;
  tmpl_P->val.line_no = lineNo;

  int i;
  for (i = 0; i < tmpClass.val.num_spells; i++)
    {
      if (tmpClass.val.spells[i].idx == tmpl_P->val.idx)
        {
          yyerror (xasprintf ("duplicate spell %s", s));
          return;
        }
    }
  char *id = xasprintf ("spell %s", s);
  if (!tmpl_P->def.level)
    NotDefined(id, "LEVEL");
  if (!tmpl_P->def.mana)
    NotDefined(id, "MANA");
  if (!tmpl_P->def.fail)
    NotDefined(id, "FAIL");
  if (!tmpl_P->def.exp)
    NotDefined(id, "EXP");
  if (consistency_check)
    CheckSpell (&tmpl_P->val.s);
  tmpClass.val.num_spells++;
  int num = tmpClass.val.num_spells;
  tmpClass.val.spells = realloc (tmpClass.val.spells,  
                                 num * sizeof(spell_t));
  tmpClass.val.spells[num-1] = tmpl_P->val;
  free (id);
}

int
name_block_contains_type (struct name_block_t *names, int num_names, int type)
{
  int i;
  for (i = 0; i < num_names; i++)
    {
      if (names[i].val == type)
        return 1;
    }
  return 0;
}

int
CheckSpellName (char *token, char *name, int type)
{
  if (name_block_contains_type (spell_names, num_spells_named, type))
    {
      yyerror (xasprintf("spell `%s' appears more than once in spell_names", token));
      return 1;
    }
  return 0;
}

void
PutSpellInfo (char *s, char *name, char *description, int consistency_check)
{
  //check if token is a spell name.
  generic_t gval;
  int type;
  if (St_GetSym (spellsT_P, s, &type, &gval) != ST_SYM_FOUND) 
    {
      yyerror (xasprintf("unknown spell `%s'", s));
      return;
    }
  if (consistency_check)
    {
       if (CheckSpellName(s, name, gval.i))
         return;
    }
  num_spells_named++;
  spell_names = realloc (spell_names, num_spells_named * sizeof (struct name_block_t));
  spell_names[num_spells_named-1].name = strdup (name);
  spell_names[num_spells_named-1].description = strdup (description);
  spell_names[num_spells_named-1].val = gval.i;
}

int
CheckPrayerName (char *token, char *name, int type)
{
  if (name_block_contains_type (prayer_names, num_prayers_named, type))
    {
      yyerror (xasprintf("prayer `%s' appears more than once in prayer_names", token));
      return 1;
    }
  return 0;
}

void
PutPrayerInfo (char *s, char *name, char *description, int consistency_check)
{
  //check if token is a prayer name.
  generic_t gval;
  int type;
  if (St_GetSym (prayersT_P, s, &type, &gval) != ST_SYM_FOUND) 
    {
      yyerror (xasprintf("unknown prayer `%s'", s));
      return;
    }
  if (consistency_check)
    {
       if (CheckPrayerName(s, name, gval.i))
         return;
    }
  num_prayers_named++;
  prayer_names = realloc (prayer_names, num_prayers_named * sizeof (struct name_block_t));
  prayer_names[num_prayers_named-1].name = strdup (name);
  prayer_names[num_prayers_named-1].description = strdup (description);
  prayer_names[num_prayers_named-1].val = gval.i;
}


void
PutPrayer (char *s, spell_template_t *tmpl_P, int consistency_check)
{
  generic_t gval;
  int type;
  if (St_GetSym (prayersT_P, s, &type, &gval) != ST_SYM_FOUND) 
    {
      yyerror (xasprintf("unknown prayer `%s'", s));
      return;
    }
  tmpl_P->val.idx = gval.i;
  tmpl_P->val.line_no = lineNo;
  int i;
  for (i = 0; i < tmpClass.val.num_prayers; i++)
    {
      if (tmpClass.val.prayers[i].idx == tmpl_P->val.idx)
        {
          yyerror (xasprintf ("duplicate prayer %s", s));
          return;
        }
    }
  char *id = xasprintf ("prayer %s", s);
  if (!tmpl_P->def.level)
    NotDefined(id, "LEVEL");
  if (!tmpl_P->def.mana)
    NotDefined(id, "MANA");
  if (!tmpl_P->def.fail)
    NotDefined(id, "FAIL");
  if (!tmpl_P->def.exp)
    NotDefined(id, "EXP");
  if (consistency_check)
    CheckSpell (&tmpl_P->val.s);
  tmpClass.val.num_prayers++;
  int num = tmpClass.val.num_prayers;
  tmpClass.val.prayers = realloc (tmpClass.val.prayers,  
                                 num * sizeof(spell_t));
  tmpClass.val.prayers[num-1] = tmpl_P->val;
  free (id);
}

int compare_ints (const void *i1, const void *i2)
{
  int num1 = *(int*)i1;
  int num2 = *(int*)i2;
  return num1 - num2;
}

void CheckBackground (int chart, int next)
{
  //check to see if the background has no dup rolls, and a roll of 100.
  int i;
  int rolls[tmpRace.val.num_backgrounds];
  int num_rolls = 0;
  if (chart == 0)
    yyerror ("invalid background id of 0");
  if (chart == next)
    yyerror ("next background id can't point to this background");
  memset (rolls, 0, sizeof (rolls));
  for (i = 0; i < tmpRace.val.num_backgrounds; i++)
    {
      if (tmpRace.val.backgrounds[i].chart != chart)
        continue;
      if (tmpRace.val.backgrounds[i].next != next)
        { 
          yyerror ("background has duplicate id or points " 
                   "to wrong next background");
          return;
        }
      rolls[num_rolls] = tmpRace.val.backgrounds[i].roll;
      num_rolls++;
    }
  qsort (rolls, num_rolls, sizeof (int), compare_ints);
  for (i = 0; i < num_rolls; i++)
    {
      if (rolls[i] == rolls[i-1])
        {
          yyerror (xasprintf ("duplicate roll value of %d", rolls[i]));
          return;
        }
    }
  if (num_rolls)
    {
      if (rolls[num_rolls-1] != 100)
        {
          yyerror ("background needs fragment with roll of 100");
          return;
        }
      if (rolls[0] == 0)
        {
          yyerror ("background has fragment with roll of 0");
          return;
        }
    }
}

void WriteGenerationNotice()
{
  fprintf (arguments.rcc.outfile,
	   "/* The following was generated by the %s race & class compiler \n"
           "   (%s-rcc %s) on %s. \n", 
           PACKAGE_NAME, GAME_NAME, VERSION, __DATE__);
  fprintf (arguments.rcc.outfile,"\n\
   Copyright (c) 1989-94 James E. Wilson, Robert A. Koeneke\n\
   This program is free software; you can redistribute it and/or modify\n\
   it under the terms of the GNU General Public License as published by\n\
   the Free Software Foundation; either version 3 of the License, or\n\
   (at your option) any later version.\n\
   \n\
   This program is distributed in the hope that it will be useful,\n\
   but WITHOUT ANY WARRANTY; without even the implied warranty of\n\
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n\
   GNU Library General Public License for more details.\n\
   \n\
   You should have received a copy of the GNU General Public License\n\
   along with this program; if not, write to the Free Software\n\
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.\n");
  fprintf (arguments.rcc.outfile,
	   "*/\n\n");
  return;
}

void 
PutClass (char *s, class_template_t *tmpl_P, int consistency_check)
{
  generic_t gval;

  gval.v = malloc (sizeof(class_template_t));
  *(class_template_t *) gval.v = *tmpl_P;

  if (!tmpl_P->def.hit_points)
    NotDefined (tmpl_P->val.c.title, "HIT_POINTS");
  if (!tmpl_P->def.disarming)
    NotDefined (tmpl_P->val.c.title, "DISARMING");
  if (!tmpl_P->def.search_chance)
    NotDefined (tmpl_P->val.c.title, "SEARCH_CHANCE");
  if (!tmpl_P->def.stealth_factor)
    NotDefined (tmpl_P->val.c.title, "STEALTH_FACTOR");
  if (!tmpl_P->def.frequency_of_search)
    NotDefined (tmpl_P->val.c.title, "FREQUENCY_OF_SEARCH");
  if (!tmpl_P->def.base_to_hit)
    NotDefined (tmpl_P->val.c.title, "BASE_TO_HIT");
  if (!tmpl_P->def.base_to_hit_with_bows)
    NotDefined (tmpl_P->val.c.title, "BASE_TO_HIT_WITH_BOWS");
  if (!tmpl_P->def.saving_throw)
    NotDefined (tmpl_P->val.c.title, "SAVING_THROW");
  if (!tmpl_P->def.strength_modifier)
    NotDefined (tmpl_P->val.c.title, "STRENGTH_MODIFIER");
  if (!tmpl_P->def.intelligence_modifier)
    NotDefined (tmpl_P->val.c.title, "INTELLIGENCE_MODIFIER");
  if (!tmpl_P->def.wisdom_modifier)
    NotDefined (tmpl_P->val.c.title, "WISDOM_MODIFIER");
  if (!tmpl_P->def.dexterity_modifier)
    NotDefined (tmpl_P->val.c.title, "DEXTERITY_MODIFIER");
  if (!tmpl_P->def.constitution_modifier)
    NotDefined (tmpl_P->val.c.title, "CONSTITUTION_MODIFIER");
  if (!tmpl_P->def.charisma_modifier)
    NotDefined (tmpl_P->val.c.title, "CHARISMA_MODIFIER");
  if (!tmpl_P->def.experience_factor)
    NotDefined (tmpl_P->val.c.title, "EXPERIENCE_FACTOR");
  if (!tmpl_P->def.adjust_base_to_hit)
    NotDefined (tmpl_P->val.c.title, "ADJUST_BASE_TO_HIT");
  if (!tmpl_P->def.adjust_base_to_hit_with_bows)
    NotDefined (tmpl_P->val.c.title, "ADJUST_BASE_TO_HIT_WITH_BOWS");
  if (!tmpl_P->def.adjust_use_device)
    NotDefined (tmpl_P->val.c.title, "ADJUST_USE_DEVICE");
  if (!tmpl_P->def.adjust_disarming)
    NotDefined (tmpl_P->val.c.title, "ADJUST_DISARMING");
  if (!tmpl_P->def.adjust_saving_throw)
    NotDefined (tmpl_P->val.c.title, "ADJUST_SAVING_THROW");

  if (St_DefSym (classT_P, s, GEN_TYPE_TMPL, gval) == ST_SYM_FOUND) 
    {
      fprintf (arguments.rcc.outfile, "Warning: redefining \"%s\", line %d\n", 
               tmpl_P->val.c.title, lineNo);
    }

  return;
}

race_template_t* get_race(char *race)
{
  race_template_t *r;
  generic_t gval;
  int type;
  if (St_GetSym (raceT_P, race, &type, &gval) != ST_SYM_FOUND) 
    return NULL;
  r = (race_template_t*) gval.v;
  return r;
}

char *get_race_for_idx(int idx)
{
  char *argz = NULL;
  size_t argz_len = 0;
  char *entry = NULL;
  St_SArgzTable (raceT_P, &argz, &argz_len);
  race_template_t *r;
  generic_t gval;
  int type;
  while ((entry = argz_next (argz, argz_len, entry)))
    {
      if (St_GetSym (raceT_P, entry, &type, &gval) != ST_SYM_FOUND) 
        continue;
      r = (race_template_t*) gval.v;
      if (r->idx == idx)
        return r->val.r.trace;
    }
  return NULL;
}


void 
WriteConstants ()
{
  fprintf (arguments.rcc.outfile, "#ifndef RACE_CLASS_CONSTANT_H\n");
  fprintf (arguments.rcc.outfile, "#define RACE_CLASS_CONSTANT_H\n");

  fprintf (arguments.rcc.outfile, "#define MAX_PLAYER_LEVEL %3d    %s\n", 
           num_experience_levels, 
           "/* Maximum possible character level      */");
  if (num_experience_levels > 0)
    fprintf (arguments.rcc.outfile, "#define MAX_EXP  %10dL    %s\n", 
             experience_levels[num_experience_levels-1]-1,
             "/* Maximum amount of experience -CJS- */");
  else
    fprintf (arguments.rcc.outfile, "#define MAX_EXP   %10d    %s\n", 0,
             "/* Maximum amount of experience -CJS- */");
  fprintf (arguments.rcc.outfile, "#define MAX_RACES      %5d    %s\n", 
           St_TableSize(raceT_P),
           "/* Number of defined races               */");
  fprintf (arguments.rcc.outfile, "#define MAX_CLASS      %5d    %s\n", 
           St_TableSize(classT_P),
           "/* Number of defined classes             */");

  int num_backgrounds = 0;
  int i;
  int num_races = St_TableSize(raceT_P);
  for (i = 0; i < num_races; i++)
    {
      char *race = get_race_for_idx(i);
      if (!race)
        continue;
      race_template_t *r = get_race(race);
      num_backgrounds += r->val.num_backgrounds;
    }
  fprintf (arguments.rcc.outfile, "#define MAX_BACKGROUND   %3d    %s\n",
           num_backgrounds, "/* Number of types of histories for univ */");
  fprintf (arguments.rcc.outfile, "#define MAX_OWNERS     %5d    %s\n", 
           num_shopkeeps, "/* Number of owners to choose from       */");
  fprintf (arguments.rcc.outfile, "#endif\n");
}

void CheckRace (race_template_t *race)
{
  int i;
  for (i = 0; i < race->val.num_price_adjust; i++)
    {
      generic_t gval;
      int type;
      if (St_GetSym (raceT_P, race->val.price_adjust[i].race, 
                     &type, &gval) != ST_SYM_FOUND) 
        {
          ErrMsgLineNo (xasprintf("unknown race `%s'", 
                                   race->val.price_adjust[i].race), 
                        race->line_no_for_price_adjust);
        }
    }
  if (race->val.num_price_adjust != St_TableSize(raceT_P))
    {
      ErrMsgLineNo ("missing races in store price adjust block", 
                    race->line_no_for_price_adjust);
    }
  
  char *entry = NULL;
  while ((entry = argz_next (race->val.classes_argz, race->val.classes_len, 
                             entry)))
    {
      generic_t gval;
      int type;
      if (St_GetSym (classT_P, entry, &type, &gval) != ST_SYM_FOUND) 
        {
          ErrMsgLineNo (xasprintf("unknown class `%s'", entry), 
                        race->line_no_for_classes);
        }
    }
}

int check_background_chart (int chart, background_type *b, int num, int *depth)
{
  //recursively check the chart until we get zero, or loop too many times.
  //or we don't find a chart.
  int i;
  int found = 0;
  int next = -1;
  for (i = 0; i < num; i++)
    {
      if (b[i].chart == chart)
        {
          next = b[i].next;
          found = 1;
        }
    }
  if (!found)
    return -1;
  *depth  = *depth + 1;
  if (*depth > num)
    return -2;
  for (i = 0; i < num; i++)
    {
      if (b[i].chart == next)
        {
          found = 1;
          break;
        }
    }
  if (!found)
    return -3;
  else if (next == 0)
    return 0;
  else
    return check_background_chart (next, b, num, depth);
}

int is_starting_chart(int chart)
{
  int i;
  int num_races = St_TableSize(raceT_P);
  for (i = 0; i < num_races; i++)
    {
      char *race = get_race_for_idx(i);
      if (!race)
        continue;
      race_template_t *r = get_race(race);
      if (r->val.num_backgrounds && r->val.backgrounds[0].chart == chart)
        return 1;
    }
  return 0;
}

void CheckRaces()
{
  char *argz = NULL;
  size_t argz_len = 0;;
  char *entry = NULL;
  int type;
  int num_races = St_TableSize(raceT_P);
  if (num_races == 0)
    {
      ErrMsgLineNo("no race blocks found", -1);
      return;
    }
  generic_t gval;
  St_SArgzTable (raceT_P, &argz, &argz_len);
  race_template_t *r;
  int num_backgrounds = 0;
  int starting_chart[num_races];
  int race_count = 0;
  while ((entry = argz_next (argz, argz_len, entry)))
    {
      if (St_GetSym (raceT_P, entry, &type, &gval) != ST_SYM_FOUND) 
        {
          fprintf (stderr, "internal err. in CheckRaces\n");
          exit (1);
        }
      r = (race_template_t *) gval.v;
      CheckRace(r);
      num_backgrounds += r->val.num_backgrounds;
      starting_chart[race_count] = r->val.backgrounds[0].chart;
      race_count++;
    }

  //collect the backgrounds into a single array
  entry = NULL;
  if (num_backgrounds)
    {
      int count = 0;
      int i;
      background_type backgrounds[num_backgrounds];
      while ((entry = argz_next (argz, argz_len, entry)))
        {
          if (St_GetSym (raceT_P, entry, &type, &gval) != ST_SYM_FOUND) 
            continue;
          r = (race_template_t *) gval.v;
          for (i = 0; i < r->val.num_backgrounds; i++)
            {
              backgrounds[count] = r->val.backgrounds[i];
              count++;
            }
        }
      for (i = 0; i < num_races; i++)
        {
          int depth = 0;
          int chart = starting_chart[i];
          if (check_background_chart(chart, backgrounds, num_backgrounds, &depth))
            ErrMsgLineNo (xasprintf ("background %d isn't complete, or loops infinitely", chart), -1);
        }

      int j;
      //every next needs a chart except for 0.
      for (i = 0; i < num_backgrounds; i++)
        {
          if (backgrounds[i].next == 0)
            continue;
          int found = 0;
          for (j = 0; j < num_backgrounds; j++)
            {
              if (backgrounds[j].chart == backgrounds[i].next)
                {
                  found = 1;
                  break;
                }
            }
          if (!found)
            {
              ErrMsgLineNo(xasprintf("background %d points to non-existent next", backgrounds[i].chart), -1);
              break;
            }
        }
        //each chart needs a next that points to it except for starting ones.
      for (i = 0; i < num_backgrounds; i++)
        {
          if (is_starting_chart(backgrounds[i].chart))
            continue;
          int found = 0;
          for (j = 0; j < num_backgrounds; j++)
            {
              if (backgrounds[j].next == backgrounds[i].chart)
                {
                  found = 1;
                  break;
                }
            }
          if (!found)
            {
              ErrMsgLineNo(xasprintf("background %d doesn't have another background pointing to it", backgrounds[i].chart), -1);
              break;
            }
        }
    }

  int shopkeeps[MAX_STORES];
  memset (shopkeeps, 0, sizeof (shopkeeps));
//check for one shopkeep for every pstore.
  entry = NULL;
  while ((entry = argz_next (argz, argz_len, entry)))
    {
      int i;
      if (St_GetSym (raceT_P, entry, &type, &gval) != ST_SYM_FOUND) 
        continue;
      r = (race_template_t *) gval.v;
      for (i = 0; i < r->val.num_shopkeeps; i++)
        shopkeeps[r->val.shopkeeps[i].pstore]++;
    }
  int j;
  for (j = 0; j < MAX_STORES; j++)
    if (shopkeeps[j] == 0)
      ErrMsgLineNo (xasprintf ("store '%c' doesn't have any shopkeeps", 
                               j + '1'), -1);
}

void CheckClass(class_template_t *c)
{
  if (c->val.num_spells && c->val.num_prayers)
    {
      ErrMsgLineNo(xasprintf("Class `%s' can't have both spells and prayers", c->val.c.title), -1);
    }
  int i;
  int max_levels = num_experience_levels;
  for (i = 0; i < c->val.num_spells; i++)
    {
      if (c->val.spells[i].s.slevel > max_levels)
        ErrMsgLineNo(xasprintf("spell has level exceeding %d", max_levels), c->val.spells[i].line_no);
    }
  for (i = 0; i < c->val.num_prayers; i++)
    {
      if (c->val.prayers[i].s.slevel > max_levels)
        ErrMsgLineNo(xasprintf("prayer has level exceeding %d", max_levels), c->val.prayers[i].line_no);
    }
  if (num_experience_levels != 
      argz_count (c->val.male_titles_argz, c->val.male_titles_len))
    {
      ErrMsgLineNo(xasprintf("%d titles given for `%s' but need %d",
                             argz_count(c->val.male_titles_argz, 
                                        c->val.male_titles_len),
                             c->val.c.title, max_levels), -1);
    }

    //is this class referenced by a race?
    int found = 0;
    int num_races = St_TableSize(raceT_P);
    for (i = 0; i < num_races; i++)
      {
        char *race = get_race_for_idx(i);
        if (!race)
          continue;
        race_template_t *r = get_race(race);
        char *argz = r->val.classes_argz;
        size_t len = r->val.classes_len;
        char *cl = NULL;
        while ((cl = argz_next (argz, len, cl)))
          {
            if (strcmp (cl, c->val.c.title) == 0)
              {
                found = 1;
                break;
              }
          }
        if (found)
          break;
      }
      if (!found)
        ErrMsgLineNo(xasprintf("class `%s' is not referenced by any race's "
                               "classes block.", c->val.c.title), -1);
}

void CheckClasses()
{
  char *argz = NULL;
  size_t argz_len = 0;
  char *entry = NULL;
  int type;
  generic_t gval;
  St_SArgzTable (classT_P, &argz, &argz_len);
  class_template_t *c;
  int num_classes = St_TableSize(classT_P);
  if (num_classes == 0)
    {
      ErrMsgLineNo("no class blocks found", -1);
      return;
    }
  while ((entry = argz_next (argz, argz_len, entry)))
    {
      if (St_GetSym (classT_P, entry, &type, &gval) != ST_SYM_FOUND) 
        {
          fprintf (stderr, "internal err. in CheckClasses\n");
          exit (1);
        }
      c = (class_template_t *) gval.v;
      CheckClass(c);
    }
}
      
void CheckNames()
{
  int i = 0;
  while (spellsInit[i].name != NULL)
  {
    if (!name_block_contains_type (spell_names, num_spells_named, 
                                   spellsInit[i].val))
      {
        yyerror (xasprintf ("spell %s lacks a name in spell_names", spellsInit[i].name));
      }
    i++;
  }
  i = 0;
  while (prayersInit[i].name != NULL)
  {
    if (!name_block_contains_type (prayer_names, num_prayers_named, 
                                   prayersInit[i].val))
      {
        yyerror (xasprintf ("prayer %s lacks a name in prayer_names", prayersInit[i].name));
      }
    i++;
  }
}

void WriteExperienceTable()
{
  int i;
  fprintf (arguments.rcc.outfile, "/* Base experience levels, may be adjusted"
                                  " up for race and/or class*/\n");
  fprintf (arguments.rcc.outfile, "int32u player_exp[MAX_PLAYER_LEVEL] = {");
  for (i = 0; i < num_experience_levels; i++)
    {
      if (i % 8 == 0)
        fprintf (arguments.rcc.outfile, "\n  ");
      else
        fprintf (arguments.rcc.outfile, " ");
      if (experience_levels[i] >= 32768)
        fprintf (arguments.rcc.outfile, "%dL,", experience_levels[i]);
      else
        fprintf (arguments.rcc.outfile, "%d,", experience_levels[i]);
    }
  fprintf (arguments.rcc.outfile, "\n};\n\n");
}

int sort_by_pstore (const void *s1, const void *s2)
{
  owner_type *lowner = (owner_type*) s1;
  owner_type *rowner = (owner_type*) s2;
  return lowner->pstore - rowner->pstore;
}

void WriteShopkeepTable()
{
  //dump all the shopkeeps from each race into an array
  owner_type shopkeeps[num_shopkeeps];

  char *argz = NULL;
  size_t argz_len = 0;
  char *entry = NULL;
  int type;
  int count = 0;
  int i, j, k;
  generic_t gval;
  St_SArgzTable (raceT_P, &argz, &argz_len);
  race_template_t *r;
  while ((entry = argz_next (argz, argz_len, entry)))
    {
      if (St_GetSym (raceT_P, entry, &type, &gval) != ST_SYM_FOUND) 
        continue;
      r = (race_template_t *) gval.v;
      for (i = 0; i < r->val.num_shopkeeps; i++)
        {
          shopkeeps[count] = r->val.shopkeeps[i];

          count++;
        }
    }
  qsort (shopkeeps, num_shopkeeps, sizeof (owner_type), sort_by_pstore);

  fprintf (arguments.rcc.outfile, "/* Store owners have different characteristics for pricing and haggling*/\n");
  fprintf (arguments.rcc.outfile, "owner_type owners[MAX_OWNERS] = {\n");
  owner_type *o = NULL;
  int last_idx[MAX_STORES];
  memset (last_idx, 0, sizeof (last_idx));
  //here we make an attempt to dump out the shopkeeps in groups of 6.
  for (k = 0; k < num_shopkeeps; k++)
    {
      for (i = 0; i < MAX_STORES; i++)
        {
          for (j = last_idx[i]; j < num_shopkeeps; j++)
            {
              o = &shopkeeps[j];
              if (o->pstore != i)
                continue;
              fprintf (arguments.rcc.outfile, "  {\"%s\",\n", o->owner_name);
              fprintf (arguments.rcc.outfile, 
                       "   %d, %d, %d, %d, %d, %d, %d},\n", 
                       o->max_cost, o->max_inflate, o->min_inflate, 
                       o->haggle_per, o->owner_race, o->insult_max, o->pstore);
              last_idx[i] = j + 1;
              break;
            }
        }
    }
  fprintf (arguments.rcc.outfile, "};\n\n");

}

char *get_short_name_for_race(char *race)
{
  if (strcmp (race, "Half-Elf") == 0)
    return strdup ("HfE");
  else if (strcmp (race, "Halfling") == 0)
    return strdup ("Hal");
  else if (strcmp (race, "Half-Orc") == 0)
    return strdup ("HfO");
  else if (strcmp (race, "Half-Troll") == 0)
    return strdup ("HfT");
  else
    {
      char nam[4];
      memset(nam, 0, sizeof (nam));
      strncpy (nam, race, 3);
      return strdup (nam);
    }
}

int get_idx_for_race(char *race)
{
  race_template_t *r;
  generic_t gval;
  int type;
  if (St_GetSym (raceT_P, race, &type, &gval) != ST_SYM_FOUND) 
    return -1;
  r = (race_template_t*) gval.v;
  return r->idx;
}

void WriteShopkeepRacePriceAdjustmentTable()
{
  fprintf (arguments.rcc.outfile, 
           "/* Buying and selling adjustments "
           "for character race VS store   */\n");
  fprintf (arguments.rcc.outfile, 
           "/* owner race                     "
           "                               */\n");
  fprintf (arguments.rcc.outfile, 
           "int8u rgold_adj[MAX_RACES][MAX_RACES] = {\n");

  int num_races = St_TableSize(raceT_P);
  int i, j, k;
  fprintf (arguments.rcc.outfile, "%18s/* ", "");
  for (i = 0; i < num_races; i++)
    {
      char *race = get_race_for_idx(i);
      if (race)
        {
          char *s = get_short_name_for_race(race);
          fprintf (arguments.rcc.outfile, "%-3s", s);
          if (i != num_races - 1)
            fprintf (arguments.rcc.outfile, ", ");
          free (s);
        }
    }
  fprintf (arguments.rcc.outfile, " */\n");
  for (i = 0; i < num_races; i++)
    {
      char *argz = NULL;
      size_t argz_len = 0;
      char *entry = NULL;
      St_SArgzTable (raceT_P, &argz, &argz_len);
      race_template_t *r;
      generic_t gval;
      int type;
      while ((entry = argz_next (argz, argz_len, entry)))
        {
          if (St_GetSym (raceT_P, entry, &type, &gval) != ST_SYM_FOUND) 
            continue;
          r = (race_template_t*) gval.v;
          if (r->idx == i)
            {
              fprintf (arguments.rcc.outfile, "/*%-15s*/ {", r->val.r.trace);
              for (j = 0; j < num_races; j++)
                {
                  for (k = 0; k < r->val.num_price_adjust; k++)
                    {
                      if (get_idx_for_race(r->val.price_adjust[k].race) == j)
                        {
                          fprintf (arguments.rcc.outfile, "%3d", 
                                   r->val.price_adjust[k].price);
                          if (j != num_races - 1)
                            fprintf (arguments.rcc.outfile, ", ");
                        }
                    }
                }
              fprintf (arguments.rcc.outfile, "}");
              if (r->idx != num_races - 1)
                fprintf (arguments.rcc.outfile, ",");
              fprintf (arguments.rcc.outfile, "\n");
            }
        }
      free(argz);
    }
  fprintf (arguments.rcc.outfile, "};\n\n");
}

class_template_t* get_class(char *class)
{
  class_template_t *c;
  generic_t gval;
  int type;
  if (St_GetSym (classT_P, class, &type, &gval) != ST_SYM_FOUND) 
    return NULL;
  c = (class_template_t*) gval.v;
  return c;
}

char *get_class_for_idx(int idx)
{
  char *argz = NULL;
  size_t argz_len = 0;
  char *entry = NULL;
  St_SArgzTable (classT_P, &argz, &argz_len);
  class_template_t *c;
  generic_t gval;
  int type;
  while ((entry = argz_next (argz, argz_len, entry)))
    {
      if (St_GetSym (classT_P, entry, &type, &gval) != ST_SYM_FOUND) 
        continue;
      c = (class_template_t*) gval.v;
      if (c->idx == idx)
        return c->val.c.title;
    }
  return NULL;
}

void WriteTitlesForClass(char *argz, size_t len)
{
  char *entry = NULL;
  int count = 0;
  int col_count = 0;
  int first = 1;
  while ((entry = argz_next (argz, len, entry)))
    {
      if (col_count + strlen (entry) + 4 > 80)
        {
          fprintf (arguments.rcc.outfile, "\n");
          col_count = 0;
        }
      if (col_count == 0)
        {
          if (first)
            {
              fprintf (arguments.rcc.outfile, "  {");
              first = 0;
            }
          else
            fprintf (arguments.rcc.outfile, "   ");
          col_count+=3;
        }
      fprintf (arguments.rcc.outfile, "\"%s\"", entry);
      col_count += strlen (entry) + 2;
      if (count != num_experience_levels -1)
        {
          fprintf (arguments.rcc.outfile, ", ");
          col_count += 2;
        }
      count++;
      if (count == num_experience_levels)
        fprintf (arguments.rcc.outfile, "},\n");
    }
}

void WriteClassTitles()
{
  int i;
  int num_classes = St_TableSize(classT_P);
  fprintf (arguments.rcc.outfile, 
           "/* Class titles for different levels"
           "                            */\n");
  fprintf (arguments.rcc.outfile,
           "char *player_title[MAX_CLASS][2][MAX_PLAYER_LEVEL] = {\n");
  for (i = 0; i < num_classes; i++)
    {
      char *class = get_class_for_idx(i);
      if (!class)
        continue;
      class_template_t *c = get_class(class);
      fprintf (arguments.rcc.outfile, "  /* %s %-13s */\n", "Female", class);
fprintf (arguments.rcc.outfile, "{\n");
      WriteTitlesForClass(c->val.female_titles_argz, c->val.female_titles_len);
      fprintf (arguments.rcc.outfile, "  /* %s %-15s */\n", "Male", class);
      WriteTitlesForClass(c->val.male_titles_argz, c->val.male_titles_len);
fprintf (arguments.rcc.outfile, "},\n");
    }
  fprintf (arguments.rcc.outfile, "};\n\n");
}
      
void WriteRaceTable()
{
  fprintf (arguments.rcc.outfile, "/*  Race  STR,INT,WIS,DEX,CON,CHR, \n");
  fprintf (arguments.rcc.outfile, 
           "    Ages, heights, and weights (male then female)\n");
  fprintf (arguments.rcc.outfile, 
           "    Racial Bases for: dis,srh,stl,fos,bth,bthb,bsav,hitdie,\n");
  fprintf (arguments.rcc.outfile, 
           "    infra, exp base, choice-classes */\n");
  fprintf (arguments.rcc.outfile, "race_type race[MAX_RACES] = {\n");
  int i;
  int num_races = St_TableSize(raceT_P);
  for (i = 0; i < num_races; i++)
    {
      char *race = get_race_for_idx(i);
      if (!race)
        continue;
      race_template_t *r = get_race(race);
      fprintf (arguments.rcc.outfile, 
               "  {\"%s\", %hd, %hd, %hd, %hd, %hd, %hd,\n",
               r->val.r.trace, r->val.r.str_adj, r->val.r.int_adj, 
               r->val.r.wis_adj, r->val.r.dex_adj, r->val.r.con_adj,
               r->val.r.chr_adj);
      fprintf (arguments.rcc.outfile,  "   "
               "%hhu, %hhu, %hhu, %hhu, %hhu, %hhu, %hhu, %hhu, %hhu, %hhu,\n",
               r->val.r.b_age, r->val.r.m_age, r->val.r.m_b_ht, 
               r->val.r.m_m_ht, r->val.r.m_b_wt, r->val.r.m_m_wt,
               r->val.r.f_b_ht, r->val.r.f_m_ht, r->val.r.f_b_wt,
               r->val.r.f_m_wt);
      fprintf (arguments.rcc.outfile, "   "
               "%hd, %hd, %hd, %hd, %hd, %hd, %hd, %hhu, %hhu, %hhu, 0x%08X,\n",
                r->val.r.b_dis, r->val.r.srh, r->val.r.stl, r->val.r.fos,
                r->val.r.bth, r->val.r.bthb, r->val.r.bsav, r->val.r.bhitdie,
                r->val.r.infra, r->val.r.b_exp, r->val.r.rtclass);
      fprintf (arguments.rcc.outfile, "   },\n");
    }
  fprintf (arguments.rcc.outfile, "};\n\n");

}

int get_min_spell_level(class_template_t *c)
{
  int min = num_experience_levels + 1;
  int i;
  for (i = 0; i < c->val.num_spells; i++)
    if (c->val.spells[i].s.slevel < min)
      min = c->val.spells[i].s.slevel;
  for (i = 0; i < c->val.num_prayers; i++)
    if (c->val.prayers[i].s.slevel < min)
      min = c->val.prayers[i].s.slevel;
  if (min == num_experience_levels + 1)
    return 0;
  return min;
}

void WriteClassTable()
{
  fprintf (arguments.rcc.outfile,
           "/* Classes.                       "
           "                              */\n");
  fprintf (arguments.rcc.outfile, "class_type class[MAX_CLASS] = {\n");
  fprintf (arguments.rcc.outfile, "/*%-11s HP Dis Src Stl Fos bth btb sve  "
                                  "S  I  W  D Co Ch Spell Exp spl */\n", "");
  int i;
  int num_classes = St_TableSize(classT_P);
  for (i = 0; i < num_classes; i++)
    {
      char *class = get_class_for_idx(i);
      if (!class)
        continue;
      class_template_t *c = get_class(class);
      char *name = xasprintf ("\"%s\",", c->val.c.title);
      char *spells = "NONE,";
      if (c->val.num_prayers)
        spells = "PRIEST,";
      else if (c->val.num_spells)
        spells = "MAGE,";
      int min_spell_level = get_min_spell_level(c);
      fprintf (arguments.rcc.outfile, "  {%-10s "
               "%2hhu, %2hhu, %2hhu, %2hhu, %2hhu, %2hhu, %2hhu, %2hhu,"
               "%2hd,%2hd,%2hd,%2hd,%2hd,%2hd,%-7s%2hhu, %2d}", 
               name, c->val.c.adj_hd, c->val.c.mdis, c->val.c.msrh, 
               c->val.c.mstl, c->val.c.mfos, c->val.c.mbth, c->val.c.mbthb,
               c->val.c.msav, c->val.c.madj_str, c->val.c.madj_int,
               c->val.c.madj_wis, c->val.c.madj_dex, c->val.c.madj_con,
               c->val.c.madj_chr, spells, c->val.c.m_exp, min_spell_level);
      if (i != num_classes - 1)
        fprintf (arguments.rcc.outfile, ",");
      fprintf (arguments.rcc.outfile, "\n");
      free (name);
    }
  fprintf (arguments.rcc.outfile, "};\n\n");
}
      
void WriteClassLevelAdjustmentTable()
{
  fprintf (arguments.rcc.outfile,
           "/* making it 16 bits wastes a little space, but saves "
           "much signed/unsigned\n");
  fprintf (arguments.rcc.outfile,
           "   headaches in its use */\n");
  fprintf (arguments.rcc.outfile,
           "/* CLA_MISC_HIT is identical to CLA_SAVE, "
           "which takes advantage of\n");
  fprintf (arguments.rcc.outfile, "   "
           "the fact that the save values are independent of the class */\n");
  fprintf (arguments.rcc.outfile, 
           "int16 class_level_adj[MAX_CLASS][MAX_LEV_ADJ] = {\n");
  fprintf (arguments.rcc.outfile, 
           "/*%-13sbth bthb  devices disarm save/misc hit  */\n", "");
  int i;
  int num_classes = St_TableSize(classT_P);
  for (i = 0; i < num_classes; i++)
    {
      char *class = get_class_for_idx(i);
      if (!class)
        continue;
      class_template_t *c = get_class(class);
      fprintf (arguments.rcc.outfile, 
               "/* %-7s */ {%3hd, %3hd, %7hd, %5hd, %12hd}", 
               c->val.c.title, c->val.adjust_per_one_third_level[0],
               c->val.adjust_per_one_third_level[1],
               c->val.adjust_per_one_third_level[2],
               c->val.adjust_per_one_third_level[3],
               c->val.adjust_per_one_third_level[4]);
      if (i != num_classes -1)
        fprintf (arguments.rcc.outfile, ",");
      fprintf (arguments.rcc.outfile, "\n");
    }
  fprintf (arguments.rcc.outfile, 
           "};\n\n");
}

void FillClassFlagsInRaces()
{
  //here we take the list of named allowable classes for each race,
  //and we fill in the bitwise field "race_type.rtclass"
  char *argz = NULL;
  size_t argz_len = 0;
  const char *entry = NULL;
  int type;
  int num_races = St_TableSize(raceT_P);
  generic_t gval;
  St_SArgzTable (raceT_P, &argz, &argz_len);
  race_template_t *r;
  while ((entry = argz_next (argz, argz_len, entry)))
    {
      if (St_GetSym (raceT_P, entry, &type, &gval) != ST_SYM_FOUND) 
        continue;
      r = (race_template_t *) gval.v;
      char *cl = NULL;
      while ((cl = argz_next (r->val.classes_argz, r->val.classes_len, cl)))
        {
          class_template_t *c = get_class(cl);
          if (!c)
            continue;
          int mask = (int) pow (2, c->idx);
          r->val.r.rtclass |= mask;
        }
    }
}
      
int sort_by_chart_and_roll (const void *lhs, const void *rhs)
{
  background_type *l = (background_type*) lhs;
  background_type *r = (background_type*) rhs;
  int diff = l->chart - r->chart;
  if (diff == 0)
    diff = l->roll - r->roll;
  return diff;
}

void WriteBackgrounds()
{
  int num_backgrounds = 0;
  int i;
  int num_races = St_TableSize(raceT_P);
  fprintf (arguments.rcc.outfile, "/* Background information"
           "                                       */\n");
  fprintf (arguments.rcc.outfile,
           "int background_start[MAX_RACES] = { "
           "/* starting .chart not index */\n");
  for (i = 0; i < num_races; i++)
    {
      char *race = get_race_for_idx(i);
      if (!race)
        continue;
      race_template_t *r = get_race(race);
      int start = 0;
      if (r->val.num_backgrounds)
        start = r->val.backgrounds[0].chart;
      fprintf (arguments.rcc.outfile, "  %3d, /* %s */\n", 
               start, r->val.r.trace);
      num_backgrounds += r->val.num_backgrounds;
    }
  fprintf (arguments.rcc.outfile, "};\n\n");

  //collect all of the backgrounds into an array and sort them
  background_type backgrounds[num_backgrounds];
  int count = 0;
  int j;
  for (i = 0; i < num_races; i++)
    {
      char *race = get_race_for_idx(i);
      if (!race)
        continue;
      race_template_t *r = get_race(race);
      for (j = 0; j < r->val.num_backgrounds; j++)
        {
          backgrounds[count] = r->val.backgrounds[j];
          count++;
        }
    }
  qsort (backgrounds, num_backgrounds, sizeof (background_type), 
         sort_by_chart_and_roll);
   //okay, dump them out
  fprintf (arguments.rcc.outfile, 
           "background_type background[MAX_BACKGROUND] = {\n");
  for (i = 0; i < num_backgrounds; i++)
    {
      background_type b = backgrounds[i];
      fprintf (arguments.rcc.outfile, 
               "  {\"%s\", %hhu, %hhu, %hhu, %hhu}",
               b.info, b.roll, b.chart, b.next, b.bonus);
      if (i != num_backgrounds - 1)
        fprintf (arguments.rcc.outfile, ",");
      fprintf (arguments.rcc.outfile, "\n");
    }
  fprintf (arguments.rcc.outfile, "};\n\n");
}
      
void WriteClassSpells(int max, spell_t *spells, int num)
{
  int i, j;
  for (i = 0; i < max; i++)
    {
      int found = 0;
      for (j = 0; j < num; j++)
        {
          if (spells[j].idx == i)
            {
              fprintf (arguments.rcc.outfile, "   {%hhu, %hhu, %hhu, %hhu}",
                       spells[j].s.slevel, spells[j].s.smana, 
                       spells[j].s.sfail, spells[j].s.sexp);
              found = 1;
              break;
            }
        }
      if (!found)
        fprintf (arguments.rcc.outfile, "   {MAX_SPELLS, MAX_SPELLS, 0, 0}");
      if (i != max - 1)
        fprintf (arguments.rcc.outfile, ",");
      fprintf (arguments.rcc.outfile, "\n");
    }
}

void WriteSpells()
{
  fprintf (arguments.rcc.outfile,
           "spell_type magic_spell[MAX_CLASS][MAX_SPELLS] = {\n");
  int num_classes = St_TableSize(classT_P);
  int i, j;
  for (i = 0; i < num_classes; i++)
    {
      char *class = get_class_for_idx(i);
      if (!class)
        continue;
      class_template_t *c = get_class(class);
      fprintf (arguments.rcc.outfile, 
               "  {%-29s /* %-13s */\n", "", c->val.c.title);
      if (c->val.num_spells)
        WriteClassSpells((sizeof (spellsInit) / sizeof (symInit_t)) -1,
                         c->val.spells, c->val.num_spells);
      else if (c->val.num_prayers)
        WriteClassSpells((sizeof (prayersInit) / sizeof (symInit_t)) -1,
                         c->val.prayers, c->val.num_prayers);
      else
        WriteClassSpells((sizeof (spellsInit) / sizeof (symInit_t)) -1,
                         c->val.spells, 0);
      fprintf (arguments.rcc.outfile, "   }");
      if (i != num_classes - 1)
        fprintf (arguments.rcc.outfile, ",");
      fprintf (arguments.rcc.outfile, "\n");
    }
  fprintf (arguments.rcc.outfile,"};\n\n");
}

char * lookup_spell_name (int idx)
{
  char *name = NULL;
  int i;
  for (i = 0; i < num_spells_named; i++)
    {
      if (spell_names[i].val == idx)
        {
          name = spell_names[i].name;
          break;
        }
    }
  return name;
}

char * lookup_spell_description (int idx)
{
  char *desc = NULL;
  int i;
  for (i = 0; i < num_spells_named; i++)
    {
      if (spell_names[i].val == idx)
        {
          desc = spell_names[i].description;
          break;
        }
    }
  return desc;
}

char * lookup_prayer_name (int idx)
{
  char *name = NULL;
  int i;
  for (i = 0; i < num_prayers_named; i++)
    {
      if (prayer_names[i].val == idx)
        {
          name = prayer_names[i].name;
          break;
        }
    }
  return name;
}

char * lookup_prayer_description (int idx)
{
  char *description = NULL;
  int i;
  for (i = 0; i < num_prayers_named; i++)
    {
      if (prayer_names[i].val == idx)
        {
          description = prayer_names[i].description;
          break;
        }
    }
  return description;
}

void WriteSpellNames()
{
  //step 1 collect the spells
  int i, j;
  int max = (sizeof (spellsInit) / sizeof (symInit_t)) -1;
  spell_t s[max];
  memset (s, 0, sizeof (s));
  int num_classes = St_TableSize(classT_P);
  for (i = 0; i < num_classes; i++)
    {
      char *class = get_class_for_idx(i);
      if (!class)
        continue;
      class_template_t *c = get_class(class);
      if (c->val.num_spells)
        {
          for (j = 0; j < c->val.num_spells; j++)
            {
              if (s[c->val.spells[j].idx].line_no == 0)
                s[c->val.spells[j].idx] = c->val.spells[j];
            }
        }
    }
  // step 2 dump them out, all pretty-print like.
  fprintf (arguments.rcc.outfile, 
    "  /* Mage Spells */\n");
  int len = 0;
  for (i = 0; i < max; i++)
    {
      char *name = lookup_spell_name (s[i].idx);
      if (!name || s[i].line_no == 0)
        name = "";
      if (len == 0)
        {
          fprintf (arguments.rcc.outfile, "    ");
          len += 4;
        }
      len += strlen (name) + 2;
      fprintf (arguments.rcc.outfile, "\"%s\"", name);
      if (i != max -1)
        {
          fprintf (arguments.rcc.outfile, ", ");
          len += 2;
        }
      if (len >= 59)
        {
          fprintf (arguments.rcc.outfile, "\n");
          len = 0;
        }
    }
  fprintf (arguments.rcc.outfile, "\n");
}

void WritePrayerNames()
{
  //step 1 collect the prayers
  int i, j;
  int max = (sizeof (prayersInit) / sizeof (symInit_t)) -1;
  spell_t s[max];
  memset (s, 0, sizeof (s));
  int num_classes = St_TableSize(classT_P);
  for (i = 0; i < num_classes; i++)
    {
      char *class = get_class_for_idx(i);
      if (!class)
        continue;
      class_template_t *c = get_class(class);
      if (c->val.num_prayers)
        {
          for (j = 0; j < c->val.num_prayers; j++)
            {
              if (s[c->val.prayers[j].idx].line_no == 0)
                s[c->val.prayers[j].idx] = c->val.prayers[j];
            }
        }
    }
  // step 2 dump them out, all pretty-print like.
  fprintf (arguments.rcc.outfile, 
    "  /* Priest Prayers */\n");
  int len = 0;
  for (i = 0; i < max; i++)
    {
      char *name = lookup_prayer_name (s[i].idx);
      if (!name || s[i].line_no == 0)
        name = "";
      if (len == 0)
        {
          fprintf (arguments.rcc.outfile, "    ");
          len += 4;
        }
      len += strlen (name) + 2;
      fprintf (arguments.rcc.outfile, "\"%s\"", name);
      if (i != max -1)
        {
          fprintf (arguments.rcc.outfile, ", ");
          len += 2;
        }
      if (len >= 59)
        {
          fprintf (arguments.rcc.outfile, "\n");
          len = 0;
        }
    }
  fprintf (arguments.rcc.outfile, "\n");
}

void WriteSpellDescriptions ()
{
  //step 1 collect the spells
  int i, j;
  int max = (sizeof (spellsInit) / sizeof (symInit_t)) -1;
  spell_t s[max];
  memset (s, 0, sizeof (s));
  int num_classes = St_TableSize(classT_P);
  for (i = 0; i < num_classes; i++)
    {
      char *class = get_class_for_idx(i);
      if (!class)
        continue;
      class_template_t *c = get_class(class);
      if (c->val.num_spells)
        {
          for (j = 0; j < c->val.num_spells; j++)
            {
              if (s[c->val.spells[j].idx].line_no == 0)
                s[c->val.spells[j].idx] = c->val.spells[j];
            }
        }
    }

  fprintf (arguments.rcc.outfile, "  /* Mage Spells */\n");
  for (i = 0; i < max; i++)
    {
      char *desc = lookup_spell_description (s[i].idx);
      if (!desc || s[i].line_no == 0)
        desc = "";
      fprintf (arguments.rcc.outfile, "    /* %s */\n    \"%s\",\n", 
               lookup_spell_name (s[i].idx), desc);
    }
}

void WritePrayerDescriptions ()
{
  //step 1 collect the prayers
  int i, j;
  int max = (sizeof (prayersInit) / sizeof (symInit_t)) -1;
  spell_t s[max];
  memset (s, 0, sizeof (s));
  int num_classes = St_TableSize(classT_P);
  for (i = 0; i < num_classes; i++)
    {
      char *class = get_class_for_idx(i);
      if (!class)
        continue;
      class_template_t *c = get_class(class);
      if (c->val.num_prayers)
        {
          for (j = 0; j < c->val.num_prayers; j++)
            {
              if (s[c->val.prayers[j].idx].line_no == 0)
                s[c->val.prayers[j].idx] = c->val.prayers[j];
            }
        }
    }

  // step 2 dump them out, all pretty-print like.
  fprintf (arguments.rcc.outfile, "  /* Priest Prayers */\n");
  for (i = 0; i < max; i++)
    {
      char *desc = lookup_prayer_description (s[i].idx);
      if (!desc || s[i].line_no == 0)
        desc = "";
      fprintf (arguments.rcc.outfile, "    /* %s */\n    \"%s\",\n", 
               lookup_prayer_name (s[i].idx), desc);
    }
}

void WriteNames()
{
  //pad the spell and prayer names
  fprintf (arguments.rcc.outfile,
    "char *spell_names[2][MAX_SPELLS] = {\n");
  fprintf (arguments.rcc.outfile,
    "  {\n");
  WriteSpellNames ();
  fprintf (arguments.rcc.outfile,
    "  }, {\n");
  WritePrayerNames ();
  fprintf (arguments.rcc.outfile,
    "  }\n");
  fprintf (arguments.rcc.outfile,"};\n\n");
}

void WriteSpellAndPrayerDescriptions()
{
  fprintf (arguments.rcc.outfile,
    "char *spell_descriptions[2][MAX_SPELLS] = {\n");
  fprintf (arguments.rcc.outfile,
    "  {\n");
  WriteSpellDescriptions ();
  fprintf (arguments.rcc.outfile,
    "  }, {\n");
  WritePrayerDescriptions ();
  fprintf (arguments.rcc.outfile,
    "  }\n");
  fprintf (arguments.rcc.outfile,"};\n\n");
}

int
rcc_main (char *inputFilename)
{
  InitTables ();

  if (strcmp (inputFilename, "-") == 0)
    input_F = stdin;
  else
    {
      input_F = fopen (inputFilename, "r");
      if (!input_F) 
	{
	  fprintf (stderr, "Error: couldn't open file.\n");
	  return -1;
	}
    }

  if (yyparse ()) 
    {
      fprintf (stderr, "Errors prevent continuation.\n");
      return -2;
    }

  FillClassFlagsInRaces();
  if (arguments.rcc.consistency_check)
    {
      CheckRaces();
      CheckClasses();
      CheckNames();
    }
  WriteGenerationNotice();
  if (arguments.rcc.only_generate_constants)
    WriteConstants ();
  else
    {
      fprintf (arguments.rcc.outfile, "#include \"constant.h\"\n");
      fprintf (arguments.rcc.outfile, "#include \"types.h\"\n\n");
      WriteShopkeepTable();
      WriteShopkeepRacePriceAdjustmentTable();
      WriteClassTitles();
      WriteExperienceTable();
      WriteRaceTable();
      WriteClassTable();
      WriteClassLevelAdjustmentTable();
      WriteBackgrounds();
      WriteSpells();
      WriteNames();
      WriteSpellAndPrayerDescriptions();
    }

  return 0;
}
